﻿using System;
using System.Collections.Generic;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using AsReaderP52N;
using System.Threading;
using System.Runtime.InteropServices;
using System.IO.Ports;
using System.Text.RegularExpressions;
using System.Timers;
using System.Net;
using System.Net.Sockets;

namespace AsReaderP52N_Demo
{
    public partial class AsReaderP52NDemo : Form
    {
        #region global parameters
        int total_time = 0;//The total time.
        int singluationCount = 0;
        bool isConnected = false;
        ConnectType connectType = ConnectType.None;
        List<string> listIP = new List<string>();
        private delegate void ProcessDelegate();
        Thread t_search;
        bool isSearch = false;
        bool isGetAllTabData = false;
        Dictionary<string, CheckBox> dicEasCheckBoxes;
        ReadType readType;
        StopInventoryEvtSource stopInventoryEvtSource;
        InventoryStatus inventoryStatus = InventoryStatus.Stopped;
        int currentTagCount = 0;
        InventoryType inventoryType = InventoryType.None;
        IvtTagType ivtTagType = IvtTagType.None;
        System.Timers.Timer GetTemperatureTimer;
        #endregion global parameters
        public AsReaderP52NDemo()
        {
            InitializeComponent();
        }
        //protected override void WndProc(ref Message m)
        //{
        //    base.WndProc(ref m);
        //    if (isConnected) return;
        //    //检测到设备改变
        //    if (m.Msg == 0x219)
        //    {
        //        // 检测到设备插入或者设备移除
        //        if ((int)m.WParam == 0x8000 || (int)m.WParam == 0x8004)    
        //        {
        //            InitPorts(); 
        //        }
        //    }
        //}
        private void AsReaderP52N_Demo_Load(object sender, EventArgs e)
        {
#if DEBUG
            cmbTCPIPAddr.Text = "192.168.10.128";
#endif

            this.TcpServerIP.Text = GetLoaclIP();
            this.initForms();
            this.InitTimer();
            this.EnableControls();
            Device.whenSearchedDevices = GetDeviceList;
            Device.whenReceivedBaseVersion = ReceivedBaseVersion;
            Device.whenReceivedSerialParam = ReceivedSerialParam;
            Device.whenReceivedReaderTime = ReceivedReaderTime;
            Device.whenReceivedEthernetMac = ReceivedEthernetMac;
            //Device.whenReceivedHostName = ReceivedHostName;
            Device.whenReceivedEthernetIP = ReceivedEthernetIP;
            Device.whenReceivedRs485Params = ReceivedRs485Params;
            Device.whenReceivedTcpMode = ReceivedTcpMode;
            Device.whenReceivedTcpHighSpeed = ReceivedTcpHighSpeed;
            Device.whenReceivedGPIState = ReceivedGPIState;
            Device.whenReceivedGPITriggerParams = ReceivedGPITriggerParams;
            Device.whenReceivedEas = ReceivedEas;
            Device.whenReceivedHeartBeat = ReceivedHeartBeat;
            Device.whenReceivedSetResult = ReceivedSetResult;
            Device.whenReceivedEPCBaseband = ReceivedEPCBaseband;
            Device.whenReceivedAntPower = ReceivedAntPower;
            Device.whenReceivedFreqRange = ReceivedFreqRange;
            Device.whenReceivedAutoFree = ReceivedAutoFree;
            Device.whenReceivedFilter = ReceivedFilter;
            Device.whenReceivedResidenceTime = ReceivedResidenceTime;
            Device.whenReceivedFrequency = ReceivedFrequency;
            Device.whenReceivedTag = ReceivedTag;
            Device.whenReceivedMoistureTag = ReceivedMoistureTag;
            Device.whenReceivedMagnusS3Tag = ReceivedMagnusS3Tag;
            Device.whenReceivedTagReadEnd = ReceivedTagReadEnd;
            Device.whenReceivedBaseStop = ReceivedBaseStop;
            Device.whenReceivedReaderInfo = ReceivedReaderInfo;
            Device.whenReceivedCRCError = ReceivedCRCError;
            Device.whenDisconnect = ConnectError;
            Device.whenReceivedGBTag = ReceivedGBTag;
            Device.whenReceivedCommandText = ReceivedCommandText;
            Device.whenReceivedTemperatureControl = ReceivedTemperatureControl;
            Device.whenReceivedWorkTemperature = ReceivedWorkTemperature;
            Device.whenReceivedTriggerStart = ReceivedTriggerStart;
            Device.whenReceivedTriggerStop = ReceivedTriggerStop;
            Device.SetDelegates();
            dicEasCheckBoxes = new Dictionary<string, CheckBox>() {
                { ckMGPO1.Name,ckUnMGPO1},
                { ckMGPO2.Name,ckUnMGPO2},
                { ckMGPO3.Name,ckUnMGPO3},
                { ckMGPO4.Name,ckUnMGPO4},
                { ckUnMGPO1.Name,ckMGPO1},
                { ckUnMGPO2.Name,ckMGPO2},
                { ckUnMGPO3.Name,ckMGPO3},
                { ckUnMGPO4.Name,ckMGPO4},
            };
            Dictionary<int, string> kvDictonary = new Dictionary<int, string>();
            kvDictonary.Add(0, "GB，920MHz~925MHz");
            kvDictonary.Add(3, "FCC，902MHz~928MHz");
            kvDictonary.Add(4, "ETSI，865MHz~868MHz");
            //kvDictonary.Add(5, "JP，916.8MHz~920.4MHz");
            //kvDictonary.Add(10, "JPLBT，916.8MHz~920.8MHz");
            kvDictonary.Add(10, "JP，916.8MHz~920.8MHz");
            BindingSource bs = new BindingSource();
            bs.DataSource = kvDictonary;
            cmbFreqPoint.DataSource = bs;
            cmbFreqPoint.ValueMember = "Key";
            cmbFreqPoint.DisplayMember = "Value";
            cmbFreqPoint.SelectedIndex = -1;

            cmbFreqRange.DataSource = bs;
            cmbFreqRange.ValueMember = "Key";
            cmbFreqRange.DisplayMember = "Value";
        }
        void ReceivedTriggerStart(Types.GPITriggerPorts gpiTriggerPorts, Types.GPOStatus gpoStatus)
        {
            this.Invoke((Action)(() => {
                string level = gpoStatus == Types.GPOStatus.Low_level ? "low" : "high";
                if (connectType == ConnectType.RS232)
                {
                    ShowMessage($"[{cmbPortRs232.SelectedItem}:{cmbConnBaudRate232.Text}][Gpi {Convert.ToByte(gpiTriggerPorts)} start][{level}]");
                }
                else if (connectType == ConnectType.TCP)
                {
                    ShowMessage($"[{cmbTCPIPAddr.Text}:{TcpPort.Text}][Gpi {Convert.ToByte(gpiTriggerPorts)} start][{level}]");
                }
                else if (connectType == ConnectType.RS485)
                {
                    ShowMessage($"[{cmbPortRs485.SelectedItem}:{cmbConnBaudRate485.Text}:{txtBaudRate485Address.Text}][Gpi {Convert.ToByte(gpiTriggerPorts)} start][{level}]");
                }
            }));
        }
        void ReceivedTriggerStop(Types.GPITriggerPorts gpiTriggerPorts, Types.GPOStatus gpoStatus)
        {
            this.Invoke((Action)(() =>
            {
                string level = gpoStatus == Types.GPOStatus.Low_level ? "low" : "high";
                if (connectType == ConnectType.RS232)
                {
                    ShowMessage($"[{cmbPortRs232.SelectedItem}:{cmbConnBaudRate232.Text}][Gpi {Convert.ToByte(gpiTriggerPorts)} over][{level}]");
                }
                else if (connectType == ConnectType.TCP)
                {
                    ShowMessage($"[{cmbTCPIPAddr.Text}:{TcpPort.Text}][Gpi {Convert.ToByte(gpiTriggerPorts)} over][{level}]");
                }
                else if (connectType == ConnectType.RS485)
                {
                    ShowMessage($"[{cmbPortRs485.SelectedItem}:{cmbConnBaudRate485.Text}:{txtBaudRate485Address.Text}][Gpi {Convert.ToByte(gpiTriggerPorts)} over][{level}]");
                }
            }));
        }
        void ReceivedCommandText(string commandText)
        {
            if (commandText.IndexOf("INVENTORY_TAG") >= 0 && (readType == ReadType.Inventory || readType == ReadType.None)) return;
            this.Invoke((Action)(() =>
            {
                ShowMessage(commandText);
            }));
        }
        void ReceivedWorkTemperature(WorkTemperature workTemperature)
        {
            this.Invoke(
                new Action(delegate
                {
                    ShowMessage("Received Work Temperature");
                    lblWorkTemp.Text = workTemperature.TemperatureWork + "℃";
                    lblTemperatureWarning.Visible = true;
                })
                );
        }
        void ReceivedTemperatureControl(string currentTemperature)
        {
            this.Invoke(
                new Action(delegate
                {
                    ShowMessage("Received Temperature");
                    lblWorkTemp.Text = currentTemperature + "℃";
                })  
                );
        }
        void ConnectError()
        {
            if (isConnected)
            {
                this.Invoke((Action)(() =>
                {
                    ShowMessage("The remote connection has been disconnected.");
                    if (connectType == ConnectType.RS232) btnRS232Disconnect_click(null, null);
                    if (connectType == ConnectType.TCP) btnTcpDiscon_Click(null, null);
                    if (connectType == ConnectType.RS485) btnRS485Disconnect_Click(null, null);
                    if (connectType == ConnectType.TCPS) btnTCPDiscServer_Click(null, null);
                }));
            }
        }
        void EnableControlsWhenSearch(bool isShow)
        {
            btnTcpConnect.Enabled = isShow;
            btnTcpServer.Enabled = isShow;
            btnRS232Connect.Enabled = isShow;
            btnRS485Connect.Enabled = isShow;
        }
        private void initForms()
        {
            tabRFIDBase1.Parent = null;
            SetComboxList();
            InitPorts();
        }
        void InitPorts()
        {
            string[] vcpPort = GetPortList();
            cmbPortRs232.Items.Clear();
            cmbPortRs485.Items.Clear();
            int i = 0;
            //有限判断是否开通端口模式
            if (vcpPort.Length > 0)
            {
                for (i = 0; i < vcpPort.Length; i++)
                {
                    this.cmbPortRs232.Items.Add(vcpPort[i]);
                    this.cmbPortRs485.Items.Add(vcpPort[i]);
                }
                if (i > 0)
                {
                    this.cmbPortRs232.SelectedIndex = 0;
                    this.cmbPortRs485.SelectedIndex = 0;
                }
            }
        }
        #region Connect
        /// <summary>
        /// VCP Connect
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnRS232Connect_Click(object sender, EventArgs e)
        {
            Cursor.Current = Cursors.WaitCursor;
            uint error = 0;
            if (cmbPortRs232.SelectedIndex < 0)
            {
                ShowMessage("Please select com port");
            }
            if (cmbConnBaudRate232.SelectedIndex < 0)
            {
                ShowMessage("Please select baud rate");
            }
            if (cmbPortRs232.SelectedIndex >= 0 && cmbConnBaudRate232.SelectedIndex >= 0)
            {
                string com_name = this.cmbPortRs232.SelectedItem.ToString();
                int baundRate = Convert.ToInt32(this.cmbConnBaudRate232.Text);
                error = Device.ConnectServerWithRS232(com_name, baundRate);
                if (error == 0)
                {
                    connectType = ConnectType.RS232;
                    WhenConnected();
                }
                else
                {
                    ShowMessage("Connect failed.(" + error + ")");
                }
                this.EnableControls();
            }
        }
        //线程通知
        private static AutoResetEvent resetEvent = new AutoResetEvent(false);
        //bool initConnect = false;
        /// <summary>
        /// TCP Connect
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnTcpConnect_Click(object sender, EventArgs e)
        {
            if (cmbTCPIPAddr.Text == "")
            {
                ShowMessage("Please input IP address.");
                return;
            }
            if (TcpPort.Text == "")
            {
                ShowMessage("Please input port.");
                return;
            }
            int port = 0;
            if (!int.TryParse(TcpPort.Text, out port))
            {
                ShowMessage("Please input correct port.");
                return;
            }
            if (!Regex.IsMatch(cmbTCPIPAddr.Text, @"^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}$"))
            {
                ShowMessage("Please input correct IP address.");
                return;
            }
            this.btnTcpConnect.Enabled = false;
            Cursor.Current = Cursors.WaitCursor;
            UInt32 error = Device.ConnectWithTcp(cmbTCPIPAddr.Text, port);
            if (error == 0)
            {
                lblTemperatureWarning.Visible = false;
                connectType = ConnectType.TCP;
                lblWorkTemp.Text = "-℃";
                GetTemperatureTimer?.Start();
                isRevBaseVersion = false;
                GetBaseVersion();
                resetEvent.WaitOne(2000);
                if (isRevBaseVersion ||
                   MessageBox.Show("This is an invalid connection.Do you like to continue?", "Tips", MessageBoxButtons.OKCancel, MessageBoxIcon.Question) == DialogResult.OK)
                {
                    //initConnect = true;
                    isConnected = true;
                    GetReaderInfo();
                }
                else
                {
                    this.btnTcpConnect.Enabled = true;
                    return;
                }
                //Task.Run(() =>
                //{
                //    Thread.Sleep(1000);
                //    Device.SendHeart();
                //});
            }
            else
            {
                ShowMessage(" Connect failed.(" + error + ")");
            }
            this.EnableControls();
            //initConnect = false;
        }
        void WhenConnected()
        {
            isRevBaseVersion = false;
            //isReceivedReaderInfo = false;
            GetBaseVersion();
            resetEvent.WaitOne(2000);
            if (!isRevBaseVersion) {
                GetBaseVersion();
                resetEvent.WaitOne(2000);
            }
            if (isRevBaseVersion ||
               MessageBox.Show("This is an invalid connection.Do you like to continue?", "Tips", MessageBoxButtons.OKCancel, MessageBoxIcon.Question) == DialogResult.OK)
            {
                //initConnect = true;
                isConnected = true;
                GetReaderInfo();
            }
            else
            {
                Device.Disconnect();
                this.btnTcpConnect.Enabled = true;
                return;
            }
            //Task.Run(() =>
            //{
            //    GetReaderInfo();
            //    GetBaseVersion();
            //});
            //isConnected = true;
            lblWorkTemp.Text = "-℃";
            lblTemperatureWarning.Visible = false;
            GetTemperatureTimer?.Start();
        }
        /// <summary>
        /// VCP disconnect
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnRS232Disconnect_click(object sender, EventArgs e)
        {
            Disconnect();
        }
        /// <summary>
        /// TCP disconnect
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnTcpDiscon_Click(object sender, EventArgs e)
        {
            Disconnect();
        }
        private void btnRs485Connect_Click(object sender, EventArgs e)
        {
            Cursor.Current = Cursors.WaitCursor;
            uint error = 0;
            string errMsg = "";
            if (cmbPortRs485.SelectedIndex < 0) errMsg = "Please select com port.";
            if (cmbConnBaudRate485.SelectedIndex < 0)
            {
                if (errMsg == "") errMsg = "Please select baud rate.";
                else errMsg += Environment.NewLine + "Please select baud rate.";
            }
            if (txtBaudRate485Address.Text == "")
            {
                if (errMsg == "") errMsg = "Please input address.";
                else errMsg += Environment.NewLine + "Please input address.";
            }
            if (errMsg != "")
            {
                ShowMessage(errMsg);
                return;
            }
            string com_name = this.cmbPortRs485.SelectedItem.ToString();
            int baundRate = Convert.ToInt32(this.cmbConnBaudRate485.Text);
            error = Device.ConnectServerWithRS485(com_name, baundRate, int.Parse(txtBaudRate485Address.Text));
            if (error == 0)
            {
                connectType = ConnectType.RS485;
                WhenConnected();
            }
            else
            {
                ShowMessage("Connect failed.(" + error + ")");
            }
            this.EnableControls();
        }
        private void btnRS485Disconnect_Click(object sender, EventArgs e)
        {
            Disconnect();
        }
        void Disconnect()
        {
            stopInventoryEvtSource = StopInventoryEvtSource.Disconnect;
            if (btnStartInventory.Text == "Stop") startInventory_Click(null, null);
            UInt32 error = Device.Disconnect();
            if (error == 0)
            {
                isConnected = false;
                this.EnableControls();
                GetTemperatureTimer?.Stop();
                ShowMessage("Disconnected");
            }
            else
            {
                ShowMessage("Disconnect failed.(" + error + ")");
            }
        }
        #endregion Connect
        #region delegate methods
        bool isRevBaseVersion = false;
        void ReceivedBaseVersion(string version)
        {
            isRevBaseVersion = true;
            if (isConnected == false) resetEvent.Set();
            this.Invoke(
                new Action(delegate
                {
                    ShowMessage("Received Base Version:" + version);
                    lblBaseBandVer.Text = version;
                })
            );
        }
        void ReceivedSerialParam(int serialParam)
        {
            this.Invoke(
                new Action(delegate
                {
                    ShowMessage("Received Serial Param:" + serialParam);
                    cmbRs232Baudrate.SelectedIndex = serialParam;
                    if (isGetAllTabData)
                    {
                        btnGetRS485Params_Click(null, null);
                    }
                })
            );
        }
        void ReceivedRs485Params(Rs485Param rs485Param)
        {
            this.Invoke(
                new Action(delegate
                {
                    //ShowMessage("Received RS485 Param:" + cmbBaudRate485.Items[rs485Param.BaudrateIndex] + rs485Param.Address);
                    txtRs485Address.Text = rs485Param.Address.ToString();
                    cmbRs485Baudrate.SelectedIndex = rs485Param.BaudrateIndex;
                    if (isGetAllTabData)
                    {
                        btnGetEthernet_Click(null, null);
                    }
                })
                );
        }
        void ReceivedEthernetIP(EthernetIP ethernetIP)
        {
            this.Invoke(
                new Action(delegate
                {
                    ShowMessage("Received Ethernet IP:" + ethernetIP.IP);
                    rbStaticIP.Checked = ethernetIP.AutoOrStaticIP == (byte)Types.EthernetIPType.StaticIP;
                    rbAutoIP.Checked = ethernetIP.AutoOrStaticIP == (byte)Types.EthernetIPType.Automatic;
                    txtIP.Text = ethernetIP.IP;
                    txtMask.Text = ethernetIP.Mask;
                    txtGateway.Text = ethernetIP.Gateway;
                    txtDns1.Text = ethernetIP.Dns1;
                    txtDns2.Text = ethernetIP.Dns2;
                    if (isGetAllTabData)
                    {
                        btnGetTcpMode_Click(null, null);
                    }
                })
                );
        }
        void ReceivedTcpMode(TcpMode tcpMode)
        {
            this.Invoke(
                new Action(delegate
                {
                    ShowMessage("Received TCP Mode:" + tcpMode.CSMode.ToString());
                    //rbServer.Checked = tcpMode.CSMode == (byte)Types.CSMode.Server;
                    //rbClient.Checked = tcpMode.CSMode == (byte)Types.CSMode.Client;
                    txtServerPort.Text = tcpMode.ServerPort.ToString();
                    //txtClientIP.Text = tcpMode.ClientIP;
                    //txtClientPort.Text = tcpMode.ClientPort.ToString();
                    if (isGetAllTabData)
                    {
                        btnGetTime_Click(null, null);
                    }
                })
                );
        }
        void ReceivedReaderTime(string readTime)
        {
            this.Invoke(
                new Action(delegate
                {
                    ShowMessage("Received Reader Time:" + readTime);
                    txtReadTime.Text = readTime;
                    if (isGetAllTabData)
                    {
                        btnGetMAC_Click(null, null);
                    }
                })
             );
        }
        void ReceivedEthernetMac(string ethernetMac)
        {
            this.Invoke(
                new Action(delegate
                {
                    ShowMessage("Received Ethernet Mac:" + ethernetMac);
                    txtEthernetMac.Text = ethernetMac;
                    if (isGetAllTabData)
                    {
                        btnGetHostName_Click(null, null);
                    }
                })
            );
        }
        void ReceivedHostName(string hostName)
        {
            this.Invoke(
                new Action(delegate
                {
                    ShowMessage("Received Host Name:" + hostName);
                    txtHostName.Text = hostName;
                    isGetAllTabData = false;
                    //if (isGetAllTabData)
                    //{
                    //    Thread.Sleep(100);
                    //    btnGetTcpHighSpeed_Click(null, null);
                    //}
                })
            );
        }
        void ReceivedTcpHighSpeed(TcpHighSpeed tcpHighSpeed)
        {
            this.Invoke(
                new Action(delegate
                {
                    ShowMessage("Received Tcp High Speed:" + tcpHighSpeed.OnOff.ToString());
                    cmbTcpHighSpeed.SelectedIndex = tcpHighSpeed.OnOff;
                })
                );
        }
        void ReceivedGPIState(GPIState gpiState)
        {
            this.Invoke(
                new Action(delegate
                {
                    ShowMessage("Received GPI State.");
                    ReDisplayGPILabel(lblGPI1, gpiState.GPI1);
                    ReDisplayGPILabel(lblGPI2, gpiState.GPI2);
                    ReDisplayGPILabel(lblGPI3, gpiState.GPI3);
                    ReDisplayGPILabel(lblGPI4, gpiState.GPI4);
                    if (isGetAllTabData)
                    {
                        btnGetGPITrigger_Click(null, null);
                        isGetAllTabData = false;
                    }
                })
                );
        }
        void ReceivedGPITriggerParams(GPITriggerParams gpiTriggerParams)
        {
            this.Invoke(
                new Action(delegate
                {
                    ShowMessage("Received GPI Trigger Parameters.");
                    cmbGPITriggerStart.SelectedIndex = gpiTriggerParams.TriggerStartCondition;
                    txtGPITriggerCmd.Text = gpiTriggerParams.TriggerBindCommand;
                    txtDelayTime.Text = gpiTriggerParams.DelayTime.ToString();
                    cmbGPITriggerStop.SelectedIndex = gpiTriggerParams.TriggerStopCondition;
                    cbReportOnOff.Checked = gpiTriggerParams.ReportOnOff == (int)Types.ReportOnOff.ReportOn;
                })
                );
        }
        void ReceivedEas(EasInfo eas)
        {
            this.Invoke(
                new Action(delegate
                {
                    ShowMessage("Received EAS.");
                    cmbEasOnOff.SelectedIndex = eas.AlarmOnOff;
                    cmbMatchArea.SelectedIndex = eas.MatchArea;
                    txtMatchStart.Text = eas.MatchStart.ToString();
                    txtMatchData.Text = eas.MatchData;
                    txtEasMask.Text = eas.Mask;
                    txtEASMKeepTimes.Text = eas.EASMatchedAction.KeepTime.ToString();
                    txtEASUnMKeepTimes.Text = eas.EASUnMatchedAction.KeepTime.ToString();
                    ckMGPO1.Checked = false;
                    ckMGPO2.Checked = false;
                    ckMGPO3.Checked = false;
                    ckMGPO4.Checked = false;
                    ckUnMGPO1.Checked = false;
                    ckUnMGPO2.Checked = false;
                    ckUnMGPO3.Checked = false;
                    ckUnMGPO4.Checked = false;
                    if (eas.EASMatchedAction.GPO1 != null)
                    {
                        ckMGPO1.Checked = true;
                        cmbMGPO1.SelectedIndex = byte.Parse(eas.EASMatchedAction.GPO1);
                    }
                    if (eas.EASMatchedAction.GPO2 != null)
                    {
                        ckMGPO2.Checked = true;
                        cmbMGPO2.SelectedIndex = byte.Parse(eas.EASMatchedAction.GPO2);
                    }
                    if (eas.EASMatchedAction.GPO3 != null)
                    {
                        ckMGPO3.Checked = true;
                        cmbMGPO3.SelectedIndex = byte.Parse(eas.EASMatchedAction.GPO3);
                    }
                    if (eas.EASMatchedAction.GPO4 != null)
                    {
                        ckMGPO4.Checked = true;
                        cmbMGPO4.SelectedIndex = byte.Parse(eas.EASMatchedAction.GPO4);
                    }
                    //EASUnMatchedAction
                    if (eas.EASUnMatchedAction.GPO1 != null)
                    {
                        ckUnMGPO1.Checked = true;
                        cmbUnMGPO1.SelectedIndex = byte.Parse(eas.EASUnMatchedAction.GPO1);
                    }
                    if (eas.EASUnMatchedAction.GPO2 != null)
                    {
                        ckUnMGPO2.Checked = true;
                        cmbUnMGPO2.SelectedIndex = byte.Parse(eas.EASUnMatchedAction.GPO2);
                    }
                    if (eas.EASUnMatchedAction.GPO3 != null)
                    {
                        ckUnMGPO3.Checked = true;
                        cmbUnMGPO3.SelectedIndex = byte.Parse(eas.EASUnMatchedAction.GPO3);
                    }
                    if (eas.EASUnMatchedAction.GPO4 != null)
                    {
                        ckUnMGPO4.Checked = true;
                        cmbUnMGPO4.SelectedIndex = byte.Parse(eas.EASUnMatchedAction.GPO4);
                    }
                })
                );
        }
        void ReceivedHeartBeat(byte[] data)
        {
            if (data != null && data.Length > 0)
            {
                Device.SendHeartBeatBuffer(data);
                ShowMessage("HeartBeat send:" + System.Text.Encoding.ASCII.GetString(data));
            }
        }
        void ReceivedSetResult(string setItemName, int resultCode, string errorMsg)
        {
            if ("Frequency Range" == setItemName) { 
                Device.GetFreqRange();
            }
            this.Invoke(
                new Action(delegate
                {
                    ShowMessage(setItemName + ":" + errorMsg + "(" + resultCode.ToString() + ")");
                })
                );
        }
        void ReceivedEPCBaseband(EPCBaseband epcBaseband)
        {
            this.Invoke(
                new Action(delegate
                {
                    ShowMessage("Received EPC Baseband.");
                    cmbEPCSpeed.SelectedValue = (int)epcBaseband.EPCSpeed;
                    cmbSeesion.SelectedIndex = epcBaseband.Session;
                    cmbQV.SelectedIndex = epcBaseband.QValue;
                    cmbSearchType.SelectedIndex = epcBaseband.SearchType;
                    if (isGetAllTabData)
                    {
                        btnGetAntPower_Click(null, null);
                    }
                })
                );
        }
        void ReceivedAntPower(AntPower antPower)
        {
            this.Invoke(
                new Action(delegate
                {
                    ShowMessage("Received Ant Power.");
                    if (antPower.Ant1 != null) cmbAnt1.SelectedIndex = (byte)antPower.Ant1;
                    else cmbAnt1.SelectedIndex = -1;
                    if (antPower.Ant2 != null) cmbAnt2.SelectedIndex = (byte)antPower.Ant2;
                    else cmbAnt2.SelectedIndex = -1;
                    if (antPower.Ant3 != null) cmbAnt3.SelectedIndex = (byte)antPower.Ant3;
                    else cmbAnt3.SelectedIndex = -1;
                    if (antPower.Ant4 != null) cmbAnt4.SelectedIndex = (byte)antPower.Ant4;
                    else cmbAnt4.SelectedIndex = -1;
                    if (antPower.Ant5 != null) cmbAnt5.SelectedIndex = (byte)antPower.Ant5;
                    else cmbAnt5.SelectedIndex = -1;
                    if (antPower.Ant6 != null) cmbAnt6.SelectedIndex = (byte)antPower.Ant6;
                    else cmbAnt6.SelectedIndex = -1;
                    if (antPower.Ant7 != null) cmbAnt7.SelectedIndex = (byte)antPower.Ant7;
                    else cmbAnt7.SelectedIndex = -1;
                    if (antPower.Ant8 != null) cmbAnt8.SelectedIndex = (byte)antPower.Ant8;
                    else cmbAnt8.SelectedIndex = -1;
                    if (isGetAllTabData)
                    {
                        btnGetFreRange_Click(null, null);
                    }
                })
                );
        }
        int currentFrequencyRangeIndex = -1;
        void ReceivedFreqRange(int freqRange)
        {
            this.Invoke(
                new Action(delegate
                {
                    ShowMessage("Received Frequency Range.");
                    cmbFreqRange.SelectedValue = freqRange;
                    cmbFreqPoint.SelectedValue = freqRange;
                    currentFrequencyRangeIndex = freqRange;
                    if (isGetAllTabData)
                    {
                        btnGetAutoFree_Click(null, null);
                    }
                    if (IsSetFreqPoint)
                    {
                        btnGetFrequency_Click(null, null);
                        IsSetFreqPoint = false;
                    }
                })
                );
        }
        void ReceivedAutoFree(AutoFree autoFree)
        {
            this.Invoke(
                new Action(delegate
                {
                    ShowMessage("Received Auto Free.");
                    cmbAutoFree.SelectedIndex = autoFree.OpenClose;
                    txtAutoFreeTime.Text = autoFree.FreeTime.ToString();
                    if (isGetAllTabData)
                    {
                        btnGetFilter_Click(null, null);
                    }
                })
                );
        }
        void ReceivedFilter(Filter filter)
        {
            this.Invoke(
                new Action(delegate
                {
                    ShowMessage("Received Filter.");
                    txtFilterRepeatTime.Text = filter.RepeatTime.ToString();
                    //txtRSSIMax.Text = filter.RssiMax;
                    txtRSSIMax.Text = filter.RssiMax.Replace("-", "");
                    if (isGetAllTabData)
                    {
                        btnGetResidenceTime_Click(null, null);
                    }
                })
                );
        }
        void ReceivedResidenceTime(ResidenceTime residenceTime)
        {
            this.Invoke(
                new Action(delegate
                {
                    ShowMessage("Received Residence Time.");
                    txtAntMax.Text = residenceTime.AntMax.ToString();
                    txtFreqPoint.Text = residenceTime.FreqPoint.ToString();
                    if (isGetAllTabData)
                    {
                        btnGetFrequency_Click(null, null);
                    }
                })
                );
        }
        void ReceivedFrequency(Frequency frequency)
        {
            this.Invoke(
                new Action(delegate
                {
                    ShowMessage("Received Frequency.");
                    txtPointList.Tag = frequency.PointIndexList;
                    cmbFreqAutoFixed.SelectedIndex = frequency.FreqAutoFixed;
                    cmbFreqPoint.SelectedIndex = cmbFreqRange.SelectedIndex;
                    SetPointList(frequency.PointIndexList);
                    isGetAllTabData = false;
                })
                );
        }
        Hashtable TagHashTable = new Hashtable();
        Hashtable GBTagHashTable = new Hashtable();
        void ReceivedGBTag(GBTag tag)
        {
            this.Invoke(
               new Action(delegate
               {
                   if (readType == ReadType.Read)
                   {
                       if (tag.ReadResult != 0)
                       {
                           ShowMessage(Enum.GetName(typeof(Types.ReadResult), tag.ReadResult));
                           return;
                       }
                       ShowMessage("Received tag.");
                       //txtReadTagData.Text += (rbEPCRead.Checked ? tag.EPCBank : rbTIDRead.Checked ? tag.TID : rbUserDataRead.Checked ? tag.UserData : tag.ReservedData) + Environment.NewLine;
                   }
                   else
                   {
                       int index = 0;
                       singluationCount++;
                       if (GBTagHashTable.ContainsKey(tag.TagCode))
                       {
                           index = int.Parse(GBTagHashTable[tag.TagCode].ToString());
                           this.dgvTags.Rows[index].Cells[6].Value = tag.TagCode;
                           this.dgvTags.Rows[index].Cells[7].Value = tag.TagLength.ToString();
                           this.dgvTags.Rows[index].Cells[8].Value = tag.TID;
                           this.dgvTags.Rows[index].Cells[9].Value = tag.UserData;
                           this.dgvTags.Rows[index].Cells[12].Value = tag.AntID;
                           this.dgvTags.Rows[index].Cells[15].Value = tag.Rssi.ToString();
                           this.dgvTags.Rows[index].Cells[16].Value = int.Parse(this.dgvTags.Rows[index].Cells[16].Value.ToString()) + 1;
                       }
                       else
                       {
                           inventoryStatus = InventoryStatus.Started;
                           index = this.dgvTags.Rows.Add();
                           TagHashTable.Add(tag.TagCode, index);
                           this.dgvTags.Rows[index].Cells[0].Value = (index + 1).ToString();
                           this.dgvTags.Rows[index].Cells[1].Value = ivtTagType == IvtTagType.EPC ? "6C" : "GB";
                           this.dgvTags.Rows[index].Cells[6].Value = tag.TagCode;
                           this.dgvTags.Rows[index].Cells[7].Value = tag.TagLength.ToString();
                           this.dgvTags.Rows[index].Cells[8].Value = tag.TID;
                           this.dgvTags.Rows[index].Cells[9].Value = tag.UserData;
                           this.dgvTags.Rows[index].Cells[12].Value = tag.AntID;
                           this.dgvTags.Rows[index].Cells[15].Value = tag.Rssi.ToString();
                           this.dgvTags.Rows[index].Cells[16].Value = 1;
                       }
                       lblTotalUnique.Text = dgvTags.Rows.Count.ToString();
                       lblTotalSingulation.Text = (int.Parse(lblTotalSingulation.Text) + 1).ToString();
                       dgvTags.ClearSelection();
                       if (stopInventoryEvtSource != StopInventoryEvtSource.StopInventory && btnStartInventory.Text == "Start")
                       {
                           btnStartInventory.Text = "Stop";
                           StopTimers();
                           StartTimers();
                       }
                   }
               })
               );
        }
        void ReceivedTag(Tag tag)
        {
            this.Invoke(
               new Action(delegate
               {
                   if (readType == ReadType.Read)
                   {
                       if (tag.ReadResult != 0)
                       {
                           ShowMessage(Enum.GetName(typeof(Types.ReadResult), tag.ReadResult));
                           return;
                       }
                       ShowMessage("Received tag.");
                       txtReadTagData.Text += (rbEPCRead.Checked ? tag.EPCBank : rbTIDRead.Checked ? tag.TID : rbUserDataRead.Checked ? tag.UserData : tag.ReservedData) + Environment.NewLine;
                   }
                   else
                   {
                       int index = 0;
                       singluationCount++;
                       if (TagHashTable.ContainsKey(tag.EPC))
                       {
                           index = int.Parse(TagHashTable[tag.EPC].ToString());
                           this.dgvTags.Rows[index].Cells[5].Value = tag.PC;
                           this.dgvTags.Rows[index].Cells[8].Value = tag.TID == null ? "" : tag.TID;
                           this.dgvTags.Rows[index].Cells[9].Value = tag.UserData == null ? "" : tag.UserData;
                           this.dgvTags.Rows[index].Cells[10].Value = tag.ReservedData;
                           this.dgvTags.Rows[index].Cells[11].Value = tag.EPCBank;
                           this.dgvTags.Rows[index].Cells[12].Value = tag.AntID;
                           this.dgvTags.Rows[index].Cells[13].Value = tag.Phase;
                           this.dgvTags.Rows[index].Cells[14].Value = (tag.Channel / 1000f).ToString() + " MHz";
                           this.dgvTags.Rows[index].Cells[15].Value = tag.Rssi.ToString();
                           this.dgvTags.Rows[index].Cells[16].Value = int.Parse(this.dgvTags.Rows[index].Cells[16].Value.ToString()) + 1;
                       }
                       else
                       {
                           inventoryStatus = InventoryStatus.Started;
                           index = this.dgvTags.Rows.Add();
                           TagHashTable.Add(tag.EPC, index);
                           this.dgvTags.Rows[index].Cells[0].Value = (index + 1).ToString();
                           this.dgvTags.Rows[index].Cells[1].Value = ivtTagType == IvtTagType.EPC ? "6C" : "GB";
                           this.dgvTags.Rows[index].Cells[4].Value = tag.EPC;
                           this.dgvTags.Rows[index].Cells[5].Value = tag.PC;
                           this.dgvTags.Rows[index].Cells[8].Value = tag.TID == null ? "" : tag.TID;
                           this.dgvTags.Rows[index].Cells[9].Value = tag.UserData == null ? "" : tag.UserData;
                           this.dgvTags.Rows[index].Cells[10].Value = tag.ReservedData;
                           this.dgvTags.Rows[index].Cells[11].Value = tag.EPCBank;
                           this.dgvTags.Rows[index].Cells[12].Value = tag.AntID;
                           this.dgvTags.Rows[index].Cells[13].Value = tag.Phase;
                           this.dgvTags.Rows[index].Cells[14].Value = (tag.Channel / 1000f).ToString() + " MHz";
                           this.dgvTags.Rows[index].Cells[15].Value = tag.Rssi.ToString();
                           this.dgvTags.Rows[index].Cells[16].Value = 1;
                       }
                       lblTotalUnique.Text = dgvTags.Rows.Count.ToString();
                       lblTotalSingulation.Text = (int.Parse(lblTotalSingulation.Text) + 1).ToString();
                       dgvTags.ClearSelection();
                       if (stopInventoryEvtSource != StopInventoryEvtSource.StopInventory && btnStartInventory.Text == "Start")
                       {
                           btnStartInventory.Text = "Stop";
                           StopTimers();
                           StartTimers();
                       }
                   }
               })
               );
        }
        void ReceivedMoistureTag(Tag tag)
        {
            this.Invoke(
                    new Action(delegate
                    {
                        int index = 0;
                        singluationCount++;
                        if (TagHashTable.ContainsKey(tag.EPC))
                        {
                            index = int.Parse(TagHashTable[tag.EPC].ToString());
                            this.dgvTags.Rows[index].Cells[2].Value = Convert.ToInt16(tag.ReservedData, 16).ToString();//Moisture
                            this.dgvTags.Rows[index].Cells[16].Value = int.Parse(this.dgvTags.Rows[index].Cells[16].Value.ToString()) + 1;
                        }
                        else
                        {
                            inventoryStatus = InventoryStatus.Started;
                            index = this.dgvTags.Rows.Add();
                            TagHashTable.Add(tag.EPC, index);
                            this.dgvTags.Rows[index].Cells[0].Value = (index + 1).ToString();
                            this.dgvTags.Rows[index].Cells[1].Value = ivtTagType == IvtTagType.EPC ? "6C" : "GB";
                            this.dgvTags.Rows[index].Cells[2].Value = tag.MoistureData.ToString();//Moisture
                            this.dgvTags.Rows[index].Cells[3].Value = tag.TemperatureData == 0 ? "" : tag.TemperatureData.ToString();//Magnus-S3
                            this.dgvTags.Rows[index].Cells[4].Value = tag.EPC;
                            this.dgvTags.Rows[index].Cells[5].Value = tag.PC;
                            this.dgvTags.Rows[index].Cells[8].Value = tag.TID == null ? "" : tag.TID;
                            this.dgvTags.Rows[index].Cells[9].Value = tag.UserData == null ? "" : tag.UserData;
                            this.dgvTags.Rows[index].Cells[10].Value = tag.ReservedData == null ? "" : tag.ReservedData;
                            this.dgvTags.Rows[index].Cells[11].Value = tag.EPCBank;
                            this.dgvTags.Rows[index].Cells[12].Value = tag.AntID;
                            this.dgvTags.Rows[index].Cells[13].Value = tag.Phase;
                            this.dgvTags.Rows[index].Cells[14].Value = (tag.Channel / 1000f).ToString() + " MHz";
                            this.dgvTags.Rows[index].Cells[15].Value = tag.Rssi.ToString();
                            this.dgvTags.Rows[index].Cells[16].Value = 1;
                        }
                        lblTotalUnique.Text = dgvTags.Rows.Count.ToString();
                        lblTotalSingulation.Text = (int.Parse(lblTotalSingulation.Text) + 1).ToString();
                        dgvTags.ClearSelection();
                    })
                    );
        }
        void ReceivedMagnusS3Tag(Tag tag)
        {
            this.Invoke(
                    new Action(delegate
                    {
                        int index = 0;
                        singluationCount++;
                        if (TagHashTable.ContainsKey(tag.EPC))
                        {
                            index = int.Parse(TagHashTable[tag.EPC].ToString());
                            this.dgvTags.Rows[index].Cells[2].Value = tag.MoistureData == 0 ? "" : tag.MoistureData.ToString();//Moisture
                            this.dgvTags.Rows[index].Cells[3].Value = tag.TemperatureData;//Magnus-S3
                            this.dgvTags.Rows[index].Cells[16].Value = int.Parse(this.dgvTags.Rows[index].Cells[16].Value.ToString()) + 1;
                        }
                        else
                        {
                            inventoryStatus = InventoryStatus.Started;
                            index = this.dgvTags.Rows.Add();
                            TagHashTable.Add(tag.EPC, index);
                            this.dgvTags.Rows[index].Cells[0].Value = (index + 1).ToString();
                            this.dgvTags.Rows[index].Cells[1].Value = ivtTagType == IvtTagType.EPC ? "6C" : "GB";
                            this.dgvTags.Rows[index].Cells[2].Value = tag.MoistureData == 0 ? "" : tag.MoistureData.ToString();//Moisture
                            this.dgvTags.Rows[index].Cells[3].Value = tag.TemperatureData;//Magnus-S3
                            this.dgvTags.Rows[index].Cells[4].Value = tag.EPC;
                            this.dgvTags.Rows[index].Cells[5].Value = tag.PC;
                            this.dgvTags.Rows[index].Cells[8].Value = tag.TID == null ? "" : tag.TID;
                            this.dgvTags.Rows[index].Cells[9].Value = tag.UserData == null ? "" : tag.UserData;
                            this.dgvTags.Rows[index].Cells[10].Value = tag.ReservedData == null ? "" : tag.ReservedData;
                            this.dgvTags.Rows[index].Cells[11].Value = tag.EPCBank;
                            this.dgvTags.Rows[index].Cells[12].Value = tag.AntID;
                            this.dgvTags.Rows[index].Cells[13].Value = tag.Phase;
                            this.dgvTags.Rows[index].Cells[14].Value = (tag.Channel / 1000f).ToString() + " MHz";
                            this.dgvTags.Rows[index].Cells[15].Value = tag.Rssi.ToString();
                            this.dgvTags.Rows[index].Cells[16].Value = 1;
                        }
                        lblTotalUnique.Text = dgvTags.Rows.Count.ToString();
                        lblTotalSingulation.Text = (int.Parse(lblTotalSingulation.Text) + 1).ToString();
                        dgvTags.ClearSelection();
                    })
                    );
        }
        void ReceivedTagReadEnd(Types.ReadEndReasonCode readEndReasonCode)
        {
            this.Invoke(
                    new Action(delegate
                    {
                        ShowMessage(Enum.GetName(typeof(Types.ReadEndReasonCode), readEndReasonCode));
                        if (readType == ReadType.Inventory && rbIvtSingle.Checked)
                        {
                            btnStartInventory.Text = "Start";
                            StopTimers();
                        }
                    })
                    );
        }
        void ReceivedBaseStop(int resultCode, string msg)
        {
            this.Invoke(
                    new Action(delegate
                    {
                        if (resultCode == 0 && stopInventoryEvtSource != StopInventoryEvtSource.StartInventory)
                        {
                            btnStartInventory.Text = "Start";
                            StopTimers();
                            inventoryStatus = InventoryStatus.Stopped;
                        }
                        ShowMessage("Base Stop:" + msg);
                    })
                    );
        }
        //bool isReceivedReaderInfo = false;
        void ReceivedReaderInfo(ReaderInformation readerInfomation)
        {
            //isReceivedReaderInfo = true;
            //if (!isConnected) resetEvent.Set();
            this.Invoke(
                    new Action(delegate
                    {
                        ShowMessage("Received reader information.");
                        lblSerialNo.Text = readerInfomation.ReaderSerialNo;
                        lblReaderAppVer.Text = readerInfomation.ApplicationVer;
                        lblAppCompilationDate.Text = readerInfomation.AppCompilationTime;
                        lblBasebandCompilationDate.Text = readerInfomation.BasebandCompilationTime;
                        lblSystemDate.Text = readerInfomation.SystemVer;
                        lblReaderPowerOn.Text = readerInfomation.ReaderPowerOnTime;
                    })
                    );
        }
        void ReceivedCRCError()
        {
            this.Invoke(
                    new Action(delegate
                    {
                        string msg = "CRC error";
                        if (inventoryStatus == InventoryStatus.Stopping)
                        {
                            msg = $"{msg}.Stop failed.";
                            inventoryStatus = InventoryStatus.Starting;
                        }
                        ShowMessage(msg);
                    })
                    );
        }
        void SetPointList(string points)
        {
            txtPointList.Text = "";
            if (points == "") return;
            string fres = "";
            string[] list = points.Split(',');
            int index = 0;
            for (int i = 0; i < list.Length; i++)
            {
                index = int.Parse(list[i]);
                if (index >= lbFrequencies.Items.Count)
                {
                    fres = "";
                    continue;
                }
                if (fres == "") fres = lbFrequencies.Items[index].ToString();
                else fres += "," + lbFrequencies.Items[index].ToString();
            }
            if (fres != "") AppendToPointList(fres);
        }
        void ReDisplayGPILabel(Label label, int value)
        {
            if (value == (int)Types.GPOStatus.Low_level)
            {
                label.Text = "low";
                label.ForeColor = Color.Lime;
            }
            else
            {
                label.Text = "high";
                label.ForeColor = Color.Red;
            }
        }
        #endregion delegate methods
        #region UDP
        void GetDeviceList(string ip)
        {
            if (listIP.Contains(ip)) return;
            listIP.Add(ip);
            this.Invoke(
                new Action(
                    delegate
                    {
                        for (int i = 0; i < listIP.Count; i++)
                        {
                            if (!cmbTCPIPAddr.Items.Contains(listIP[i]))
                            {
                                cmbTCPIPAddr.Items.Add(listIP[i]);
                            }
                        }
                        if (cmbTCPIPAddr.Items.Count > 0) cmbTCPIPAddr.SelectedIndex = 0;
                        ShowMessage("IP:" + ip);
                    }
                    )
                );
        }
        /// <summary>
        /// UDP Search
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnSearch_Click(object sender, EventArgs e)
        {
            if (btnSearch.Text == "Search")
            {
                isSearch = true;
                btnSearch.Text = "Stop Search";
                EnableControlsWhenSearch(false);
            }
            else
            {
                isSearch = false;
                btnSearch.Text = "Search";
                EnableControlsWhenSearch(true);
            }
            if (!isSearch)
            {
                t_search.Abort();
                Device.StopSearchDevice();
            }
            else
            {
                listIP.Clear();
                cmbTCPIPAddr.Items.Clear();
                cmbTCPIPAddr.Text = "";
                t_search = new Thread(new ThreadStart(Device.StartSearchDevice));
                t_search.IsBackground = true;
                t_search.Start();
                Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Start Search" + Environment.NewLine);
                Devmes.ScrollToCaret();
            }
        }
        #endregion UDP

        #region input check
        private void Hex_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = ("0123456789ABCDEF".IndexOf(Char.ToUpper(e.KeyChar)) < 0);
        }
        private void HexCalLength_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = ("0123456789ABCDEF".IndexOf(Char.ToUpper(e.KeyChar)) < 0);
            if (!e.Handled)
            {
                TextBox textbox = (TextBox)sender;
                int len = textbox.SelectionLength == textbox.Text.Length ? 0 : textbox.Text.Length;
                if (e.KeyChar == '') len = len - 1;
                else len = len + 1;
                double d = len / 4.0;
                txtWriteLength.Text = Math.Ceiling(d).ToString();
            }
        }
        private void NumberOnly_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = ("0123456789".IndexOf(Char.ToUpper(e.KeyChar)) < 0);
        }
        private void NumberU8_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = ("0123456789".IndexOf(Char.ToUpper(e.KeyChar)) < 0);
            if (!e.Handled && e.KeyChar != '')//删除键
            {
                TextBox textbox = (TextBox)sender;
                string data = textbox.Text;
                if (textbox.SelectionLength < textbox.Text.Length)
                {
                    if (textbox.SelectionLength > 0) data = data.Remove(textbox.SelectionStart, textbox.SelectionLength);
                    string tmp = data.Insert(textbox.SelectionStart, e.KeyChar.ToString());
                    if (int.Parse(tmp) > 255)
                    {
                        e.Handled = true;
                    }
                }
            }
        }
        private void NumberMinus_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = ("-0123456789".IndexOf(Char.ToUpper(e.KeyChar)) < 0);
        }
        private void NumberU16_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = ("0123456789".IndexOf(Char.ToUpper(e.KeyChar)) < 0);
            if (!e.Handled && e.KeyChar != '')//删除键
            {
                TextBox textbox = (TextBox)sender;
                string data = textbox.Text;
                if (textbox.SelectionLength < textbox.Text.Length) {
                    if(textbox.SelectionLength > 0) data = data.Remove(textbox.SelectionStart, textbox.SelectionLength);
                    string tmp = data.Insert(textbox.SelectionStart, e.KeyChar.ToString());
                    if (int.Parse(tmp) > 65535)
                    {
                        e.Handled = true;
                    }
                }
            }
        }
        private void txtNumber_Leave(object sender, EventArgs e)
        {
            if (((TextBox)sender).Text == "")
            {
                ((TextBox)sender).Text = "0";
            }
        }
        #endregion input check
        private void rbIvtEPC_CheckedChanged(object sender, EventArgs e)
        {
            gbIvtDataArea.Enabled = rbIvtEPC.Checked;
        }
        private void ClearTableData()
        {
            this.dgvTags.Rows.Clear();
            this.Devmes.Text = "";
            singluationCount = 0;
            lblTotalDuration.Text = "0";
            lblTotalSingulation.Text = "0";
            lblTotalUnique.Text = "0";
            lblTotalUnique.Text = "0";
            currentTagCount = 0;
            total_time = 0;
            dgvTags.Rows.Clear();
            TagHashTable.Clear();
            lblSingulationRate.Text = "0";
            if (btnStartInventory.Text == "Stop")
            {
                StopTimers();
                StartTimers();
            }
            lblTemperatureWarning.Visible = false;
            lblWorkTemp.Text = "-℃";
        }
        private void EnableControls()
        {
            this.gbRegion.Enabled = isConnected;
            this.btnRS232Connect.Enabled = !isConnected;
            this.btnRs232DisConnect.Enabled = isConnected && connectType == ConnectType.RS232;
            this.btnRS485Connect.Enabled = !isConnected;
            this.btnRS485Disconnect.Enabled = isConnected && connectType == ConnectType.RS485;
            this.btnTcpConnect.Enabled = !isConnected;
            this.btnTCPDisconnect.Enabled = isConnected && connectType == ConnectType.TCP;
            
            this.btnTcpServer.Enabled = !isConnected;
            this.btnTCPDiscServer.Enabled = isConnected && connectType == ConnectType.TCPS;
            this.TcpServerPort.Enabled = !isConnected;
            this.TcpServerIP.Enabled = !isConnected;
            
            this.cmbPortRs232.Enabled = !isConnected;
            this.cmbConnBaudRate232.Enabled = !isConnected;
            this.TcpPort.Enabled = !isConnected;
            this.cmbTCPIPAddr.Enabled = !isConnected;
            this.btnSearch.Enabled = !isConnected;
            this.cmbPortRs485.Enabled = !isConnected;
            this.cmbConnBaudRate485.Enabled = !isConnected;
            this.txtBaudRate485Address.Enabled = !isConnected;
            this.tabSettings.Enabled = isConnected;
            this.tabInventory.Enabled = isConnected;
            if (!isConnected) btnStartInventory.Text = "Start";
            btnUpgradeBaseband.Enabled = connectType != ConnectType.RS485;
        }
        /// <summary>
        /// SetComboxList
        /// </summary>
        private void SetComboxList()
        {
            DataTable dt = new DataTable();
            dt = Device.getComboxList(typeof(Types.Baudrate));
            cmbConnBaudRate485.DataSource = dt;
            cmbConnBaudRate485.DisplayMember = "name";
            cmbConnBaudRate485.ValueMember = "value";
            cmbConnBaudRate485.SelectedIndex = 2;

            cmbConnBaudRate232.DataSource = dt.Copy();
            cmbConnBaudRate232.DisplayMember = "name";
            cmbConnBaudRate232.ValueMember = "value";
            cmbConnBaudRate232.SelectedIndex = 2;


            cmbRs485Baudrate.DataSource = dt.Copy();
            cmbRs485Baudrate.DisplayMember = "name";
            cmbRs485Baudrate.ValueMember = "value";
            cmbRs485Baudrate.SelectedIndex = 2;

            cmbRs232Baudrate.DataSource = dt.Copy();
            cmbRs232Baudrate.DisplayMember = "name";
            cmbRs232Baudrate.ValueMember = "value";
            cmbRs232Baudrate.SelectedIndex = 2;

            DataTable dtTriggerStartConditions = Device.getComboxList(typeof(Types.GPITriggerStartConditions));
            cmbGPITriggerStart.DataSource = dtTriggerStartConditions;
            cmbGPITriggerStart.DisplayMember = "name";
            cmbGPITriggerStart.ValueMember = "value";

            DataTable dtGPITriggerPorts = Device.getComboxList(typeof(Types.GPITriggerPorts));
            cmbGPITriggerPort.DataSource = dtGPITriggerPorts;
            cmbGPITriggerPort.DisplayMember = "name";
            cmbGPITriggerPort.ValueMember = "value";

            DataTable dtGPITriggerStopConditions = Device.getComboxList(typeof(Types.GPITriggerStopConditions));
            cmbGPITriggerStop.DataSource = dtGPITriggerStopConditions;
            cmbGPITriggerStop.DisplayMember = "name";
            cmbGPITriggerStop.ValueMember = "value";

            DataTable dtOnOff = Device.getComboxList(typeof(Types.OnOff));
            cmbTcpHighSpeed.DataSource = dtOnOff;
            cmbTcpHighSpeed.DisplayMember = "name";
            cmbTcpHighSpeed.ValueMember = "value";
            cmbTcpHighSpeed.SelectedIndex = -1;

            cmbEasOnOff.DataSource = dtOnOff.Copy();
            cmbEasOnOff.DisplayMember = "name";
            cmbEasOnOff.ValueMember = "value";
            cmbEasOnOff.SelectedIndex = -1;

            DataTable dtEasMatchArea = Device.getComboxList(typeof(Types.EasMatchArea));
            cmbMatchArea.DataSource = dtEasMatchArea;
            cmbMatchArea.DisplayMember = "name";
            cmbMatchArea.ValueMember = "value";
            cmbMatchArea.SelectedIndex = -1;

            DataTable dtCloseOpen = Device.getComboxList(typeof(Types.CloseOpen));
            cmbAutoFree.DataSource = dtCloseOpen;
            cmbAutoFree.DisplayMember = "name";
            cmbAutoFree.ValueMember = "value";
            cmbAutoFree.SelectedIndex = -1;

            DataTable dtFrequencyAutoFixed = Device.getComboxList(typeof(Types.FrequencyAutoFixed));
            cmbFreqAutoFixed.DataSource = dtFrequencyAutoFixed;
            cmbFreqAutoFixed.DisplayMember = "name";
            cmbFreqAutoFixed.ValueMember = "value";
            cmbFreqAutoFixed.SelectedIndex = -1;

            List<KeyValuePair<int, string>> epcBasebandList = new List<KeyValuePair<int, string>>();
            Device.GetEPCBasebandList(ref epcBasebandList);
            cmbEPCSpeed.DataSource = epcBasebandList;
            cmbEPCSpeed.DisplayMember = "Value";
            cmbEPCSpeed.ValueMember = "Key";
            cmbEPCSpeed.SelectedIndex = -1;
        }
        private void StopInventory()
        {
            if (btnStartInventory.Text == "Stop")
            {
                Device.BaseStop();
            }
        }
        public static string[] GetPortList()
        {
            return Device.GetPortNames();
        }
        private void AsReaderP52N_Demo_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (btnStartInventory.Text == "Stop") StopInventory();
            if (isConnected)
            {
                Device.Disconnect();
            }
        }
        private void btnClear_Click(object sender, EventArgs e)
        {
            ClearTableData();
        }
        #region tab events
        private void tabSettings_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (tabSettings.SelectedIndex == 0)
            {
                tabBasicSettings_SelectedIndexChanged(null, null);
            }
            if (tabSettings.SelectedIndex == 1)
            {
                tabRFID_SelectedIndexChanged(null, null);
            }
        }
        #endregion tab events

        #region basic setting
        private void tabBasicSettings_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (!isConnected) return;
            if (tabDeviceSettings.SelectedIndex == 0)
            {
                GetReaderInfo();
                GetBaseVersion();
            }
            if (tabDeviceSettings.SelectedIndex == 1)
            {
                isGetAllTabData = true;
                btnGetRS232Params_Click(null, null);
            }
            if (tabDeviceSettings.SelectedIndex == 2)
            {
                isGetAllTabData = true;
                btnGetGPIState_Click(null, null);
            }
            if (tabDeviceSettings.SelectedIndex == 3)
            {
                btnGetEAS_Click(null, null);
            }
        }
        private void btnGetRS232Params_Click(object sender, EventArgs e)
        {
            UInt32 ret = Device.GetSerialParam();
            ShowMessage(ret == 0 ? "Get Rs232 send succeed." : "Get Rs232 send failed.");
        }
        private void btnSetRS232Params_Click(object sender, EventArgs e)
        {
            if (cmbRs232Baudrate.SelectedIndex < 0)
            {
                ShowParamsNullErrorMessage();
            }
            else
            {
                Device.SetSerialParam((Types.Baudrate)cmbRs232Baudrate.SelectedIndex);
            }
        }
        private void btnGetRS485Params_Click(object sender, EventArgs e)
        {
            UInt32 ret = Device.GetRs485();
            ShowMessage(ret == 0 ? "Get Rs485 send succeed." : "Get Rs485 send failed.");
        }
        private void btnSetRS485Params_Click(object sender, EventArgs e)
        {
            try
            {
                if (cmbRs485Baudrate.SelectedIndex < 0 || txtRs485Address.Text == "")
                {
                    ShowParamsNullErrorMessage();
                }
                else
                {
                    Device.SetRs485((Types.Baudrate)cmbRs485Baudrate.SelectedIndex, int.Parse(txtRs485Address.Text));
                }
            }
            catch (Exception ex)
            {
                ShowMessage($"SetRS485Params:{ex.Message}");
            }
        }
        private void btnGetEthernet_Click(object sender, EventArgs e)
        {
            UInt32 ret = Device.GetEthernetIP();
            ShowMessage(ret == 0 ? "Get ethernet ip send succeed." : "Get ethernet ip send failed.");
        }
        private void btnSetEthernet_Click(object sender, EventArgs e)
        {
            try
            {
                IPAddress ip, mask, gateway, dns1, dns2;
                if (txtIP.Text == "" || txtMask.Text == "" || txtGateway.Text == "" || txtDns1.Text == "" || txtDns2.Text == "")
                {
                    ShowParamsNullErrorMessage();
                }
                else if (!IPAddress.TryParse(txtIP.Text, out ip) || !IPAddress.TryParse(txtMask.Text, out mask) || !IPAddress.TryParse(txtGateway.Text, out gateway) ||
                    !IPAddress.TryParse(txtDns1.Text, out dns1) || !IPAddress.TryParse(txtDns2.Text, out dns2))
                {
                    ShowParamsErrorMessage();
                }
                else
                {
                    EthernetIP ethernetIP = new EthernetIP()
                    {
                        AutoOrStaticIP = (byte)(rbStaticIP.Checked ? Types.EthernetIPType.StaticIP : Types.EthernetIPType.Automatic),
                        IP = ip.ToString(),
                        Mask = mask.ToString(),
                        Gateway = gateway.ToString(),
                        Dns1 = dns1.ToString(),
                        Dns2 = dns2.ToString(),
                    };
                    Device.SetEthernetIP(ethernetIP);
                }
            }
            catch (Exception ex)
            {
                ShowMessage($"SetEthernetIP:{ex.Message}");
            }
        }
        private void btnGetTcpMode_Click(object sender, EventArgs e)
        {
            UInt32 ret = Device.GetTcpMode();
            ShowMessage(ret == 0 ? "Get tcp mode send succeed." : "Get tcp mode send failed.");
        }
        private void btnSetTcpMode_Click(object sender, EventArgs e)
        {
            try
            {
                if (txtServerPort.Text == "")
                {
                    ShowParamsNullErrorMessage();
                }
                else 
                {
                    TcpMode tcpMode = new TcpMode()
                    {
                        CSMode = (byte)Types.CSMode.Server,
                        ServerPort = ushort.Parse(txtServerPort.Text),
                    };
                    Device.SetTcpMode(tcpMode);
                }
            }
            catch (Exception ex)
            {
                ShowMessage($"SetTcpMode:{ex.Message}");
            }
        }
        private void btnGetTime_Click(object sender, EventArgs e)
        {
            UInt32 ret = Device.GetReaderTime();
            ShowMessage(ret == 0 ? "Get time send succeed." : "Get time send failed.");
        }
        private void btnSetTime_Click(object sender, EventArgs e)
        {
            DateTime dt;
            if (txtReadTime.Text == "")
            {
                ShowParamsNullErrorMessage();
            }
            else if (!DateTime.TryParse(txtReadTime.Text, out dt))
            {
                ShowParamsErrorMessage();
            }
            else
            {
                ReaderTime time = new ReaderTime()
                {
                    UTCSecond = txtReadTime.Text,
                };
                Device.SetReaderTime(time);
            }
        }
        private void btnGetMAC_Click(object sender, EventArgs e)
        {
            UInt32 ret = Device.GetEthernetMac();
            ShowMessage(ret == 0 ? "Get ethernet mac send succeed." : "Get ethernet mac send failed.");
        }
        private void btnGetHostName_Click(object sender, EventArgs e)
        {
            //UInt32 ret = Device.GetHostName();
            //ShowMessage(ret == 0 ? "Get host name send succeed." : "Get host name send failed.");
        }
        private void btnGetTcpHighSpeed_Click(object sender, EventArgs e)
        {
            //UInt32 ret = Device.GetTcpHighSpeed();
            //ShowMessage(ret == 0 ? "Get tcp high speed send succeed." : "Get tcp high speed send failed.");
        }
        private void btnRestoreFactorySettings_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("Confirm to restore factory settings?", "Tips", MessageBoxButtons.OKCancel) == DialogResult.OK)
            {
                if (GetTemperatureTimer.Enabled) GetTemperatureTimer.Stop();
                Device.RestoreFactorySettings();
                #region #41966
                this.Enabled = false;
                Thread.Sleep(5000);
                this.Enabled = true;
                #endregion
            }
        }
        private void btnRestartDevice_Click(object sender, EventArgs e)
        {
            if (GetTemperatureTimer.Enabled) GetTemperatureTimer.Stop();
            UInt32 ret = Device.Restart();
            ShowMessage(ret == 0 ? "Restart send succeed." : "Restart send failed.");
        }
        private void rbAutoIP_CheckedChanged(object sender, EventArgs e)
        {
            txtIP.ReadOnly = txtMask.ReadOnly = txtGateway.ReadOnly = txtDns1.ReadOnly = txtDns2.ReadOnly = rbAutoIP.Checked;
        }
        #endregion basic setting

        #region GPIO Settings
        private void btnSetGPO_Click(object sender, EventArgs e)
        {
            GPO gpo = new GPO();
            if (cbGPO1.Checked && cmbGPO1.SelectedIndex >= 0)
            {
                gpo.GPO1 = cmbGPO1.SelectedIndex.ToString();
            }
            if (cbGPO2.Checked && cmbGPO2.SelectedIndex >= 0)
            {
                gpo.GPO2 = cmbGPO2.SelectedIndex.ToString();
            }
            if (cbGPO3.Checked && cmbGPO3.SelectedIndex >= 0)
            {
                gpo.GPO3 = cmbGPO3.SelectedIndex.ToString();
            }
            if (cbGPO4.Checked && cmbGPO4.SelectedIndex >= 0)
            {
                gpo.GPO4 = cmbGPO4.SelectedIndex.ToString();
            }
            Device.SetGPO(gpo);
        }
        private void btnSetBeep_Click(object sender, EventArgs e)
        {
            if (cmbBeepFreqs.SelectedIndex < 0 || cmbBeep.SelectedIndex < 0)
            {
                ShowParamsNullErrorMessage();
            }
            else
            {
                Beep beep = new Beep()
                {
                    BeepOrOff = (byte)cmbBeepOnOff.SelectedIndex,
                    OnlyoneOrKeep = (byte)cmbBeepFreqs.SelectedIndex,
                };
                Device.SetBeep(beep);
            }
        }
        private void btnSetBeepOnOff_Click(object sender, EventArgs e)
        {
            if (cmbBeepOnOff.SelectedIndex < 0)
            {
                ShowParamsNullErrorMessage();
            }
            else
            {
                Device.SetBeepOnOff(cmbBeepOnOff.SelectedIndex);
            }
        }

        private void btnGetGPIState_Click(object sender, EventArgs e)
        {
            Device.GetGpiState();
        }

        private void btnGetGPITrigger_Click(object sender, EventArgs e)
        {
            if (sender == null && cmbGPITriggerPort.SelectedIndex < 0) return;
            if (sender != null && cmbGPITriggerPort.SelectedIndex < 0) MessageBox.Show("Select the Gpi port.");
            Device.GetGpiTrigger((Types.GPITriggerPorts)cmbGPITriggerPort.SelectedIndex);
        }

        private void btnSetGPITrigger_Click(object sender, EventArgs e)
        {
            try
            {
                if (cmbGPITriggerPort.SelectedIndex < 0 && cmbGPITriggerStart.SelectedIndex < 0 && cmbGPITriggerStop.SelectedIndex < 0)
                {
                    ShowParamsNullErrorMessage();
                }
                else
                {
                    GPITriggerParamsSetting gpiTriggerParamsSet = new GPITriggerParamsSetting()
                    {
                        port = (byte)cmbGPITriggerPort.SelectedIndex,
                        TriggerStartCondition = (byte)cmbGPITriggerStart.SelectedIndex,
                        TriggerBindCommand = txtGPITriggerCmd.Text,
                        TriggerStopCondition = (byte)cmbGPITriggerStop.SelectedIndex,
                        DelayTime = UInt16.Parse(txtDelayTime.Text.ToString()),
                        ReportOnOff = cbReportOnOff.Visible && cbReportOnOff.Checked ? Types.ReportOnOff.ReportOn : Types.ReportOnOff.ReportOff,
                        //ReportOnOff = cmbGPITriggerStop.SelectedIndex == (int)Types.GPITriggerStopConditions.Off && cbReportOnOff.Checked,
                    };
                    Device.SetGpiTrigger(gpiTriggerParamsSet);
                }
            }
            catch (Exception ex)
            {
                ShowMessage($"SetGPITrigger:{ex.Message}");
            }
        }
        private void cmbGPITriggerStop_SelectedIndexChanged(object sender, EventArgs e)
        {
            cbReportOnOff.Visible = ((ComboBox)sender).SelectedIndex == 0;
            if (((ComboBox)sender).SelectedIndex == (int)Types.GPITriggerStopConditions.Delay_stop)
            {
                txtDelayTime.Enabled = true;
            }
            else
            {
                txtDelayTime.Enabled = false;
            }
        }
        #endregion GPIO Settings

        #region Cus-1 Settings
        private void btnGetEAS_Click(object sender, EventArgs e)
        {
            Device.GetEas();
        }
        private void btnSetEAS_Click(object sender, EventArgs e)
        {
            try
            {
                if (cmbEasOnOff.SelectedIndex < 0 || cmbMatchArea.SelectedIndex < 0 || txtMatchStart.Text == "" || txtMatchData.Text == "" || txtEasMask.Text == "")
                {
                    ShowParamsNullErrorMessage();
                }
                else if (txtMatchData.Text.Length != txtEasMask.Text.Length)
                {
                    ShowMessage("The matching data must be the same length as the mask.");
                }
                else
                {
                    EasInfo info = new EasInfo()
                    {
                        AlarmOnOff = (byte)cmbEasOnOff.SelectedIndex,
                        MatchArea = (byte)cmbMatchArea.SelectedIndex,
                        MatchStart = ushort.Parse(txtMatchStart.Text),
                        MatchData = txtMatchData.Text,
                        Mask = txtEasMask.Text,
                    };
                    info.EASMatchedAction = new EasAction()
                    {
                        KeepTime = ushort.Parse(txtEASMKeepTimes.Text),
                        GPO1 = ckMGPO1.Checked ? cmbMGPO1.SelectedIndex.ToString() : null,
                        GPO2 = ckMGPO2.Checked ? cmbMGPO2.SelectedIndex.ToString() : null,
                        GPO3 = ckMGPO3.Checked ? cmbMGPO3.SelectedIndex.ToString() : null,
                        GPO4 = ckMGPO4.Checked ? cmbMGPO4.SelectedIndex.ToString() : null,
                    };
                    info.EASUnMatchedAction = new EasAction()
                    {
                        KeepTime = ushort.Parse(txtEASUnMKeepTimes.Text),
                        GPO1 = ckUnMGPO1.Checked ? cmbUnMGPO1.SelectedIndex.ToString() : null,
                        GPO2 = ckUnMGPO2.Checked ? cmbUnMGPO2.SelectedIndex.ToString() : null,
                        GPO3 = ckUnMGPO3.Checked ? cmbUnMGPO3.SelectedIndex.ToString() : null,
                        GPO4 = ckUnMGPO4.Checked ? cmbUnMGPO4.SelectedIndex.ToString() : null,
                    };

                    Device.SetEas(info);
                }
            }
            catch (Exception ex)
            {
                ShowMessage($"SetEAS:{ex.Message}");
            }
        }
        private void ckEasGPO_CheckedChanged(object sender, EventArgs e)
        {
            CheckBox cb = (CheckBox)sender;
            dicEasCheckBoxes[cb.Name].Enabled = !cb.Checked;
            if (cb.Checked)
            {
                dicEasCheckBoxes[cb.Name].Checked = false;
            }
        }
        #endregion Cus-1 Settings
        #region Base
        private void GetReaderInfo()
        {
            Device.GetReaderInfo();
        }
        private UInt32 GetBaseVersion()
        {
            UInt32 ret = Device.GetBaseVersion();
            return ret;
        }
        private void btnGetEPCBaseband_Click(object sender, EventArgs e)
        {
            Device.GetEPCBaseband();
        }
        private void btnSetEPCBaseband_Click(object sender, EventArgs e)
        {
            EPCBaseband epcBaseband = new EPCBaseband()
            {
                EPCSpeed = Convert.ToByte(cmbEPCSpeed.SelectedValue.ToString()),
                Session = (byte)cmbSeesion.SelectedIndex,
                QValue = (byte)cmbQV.SelectedIndex,
                SearchType = (byte)cmbSearchType.SelectedIndex,
            };
            Device.SetEPCBaseband(epcBaseband);
        }
        private void cbAntAll_CheckedChanged(object sender, EventArgs e)
        {
            cbAnt1.Checked = cbAnt2.Checked = cbAnt3.Checked = cbAnt4.Checked = cbAnt5.Checked = cbAnt6.Checked = cbAnt7.Checked = cbAnt8.Checked = cbAntAll.Checked;
        }
        private void cmbAntAll_SelectedIndexChanged(object sender, EventArgs e)
        {
            cmbAnt1.SelectedIndex = cmbAnt2.SelectedIndex = cmbAnt3.SelectedIndex = cmbAnt4.SelectedIndex = cmbAnt5.SelectedIndex = cmbAnt6.SelectedIndex = cmbAnt7.SelectedIndex = cmbAnt8.SelectedIndex = cmbAntAll.SelectedIndex;
        }
        private void btnGetAntPower_Click(object sender, EventArgs e)
        {
            Device.GetAntPower();
        }
        private void btnSetAntPower_Click(object sender, EventArgs e)
        {
            AntPower antPower = new AntPower();
            if (cbAnt1.Checked && cmbAnt1.SelectedIndex >= 0) antPower.Ant1 = (byte)cmbAnt1.SelectedIndex;
            if (cbAnt2.Checked && cmbAnt2.SelectedIndex >= 0) antPower.Ant2 = (byte)cmbAnt2.SelectedIndex;
            if (cbAnt3.Checked && cmbAnt3.SelectedIndex >= 0) antPower.Ant3 = (byte)cmbAnt3.SelectedIndex;
            if (cbAnt4.Checked && cmbAnt4.SelectedIndex >= 0) antPower.Ant4 = (byte)cmbAnt4.SelectedIndex;
            if (cbAnt5.Checked && cmbAnt5.SelectedIndex >= 0) antPower.Ant5 = (byte)cmbAnt5.SelectedIndex;
            if (cbAnt6.Checked && cmbAnt6.SelectedIndex >= 0) antPower.Ant6 = (byte)cmbAnt6.SelectedIndex;
            if (cbAnt7.Checked && cmbAnt7.SelectedIndex >= 0) antPower.Ant7 = (byte)cmbAnt7.SelectedIndex;
            if (cbAnt8.Checked && cmbAnt8.SelectedIndex >= 0) antPower.Ant8 = (byte)cmbAnt8.SelectedIndex;
            Device.SetAntPower(antPower, cbPowerDownSave.Checked);
        }
        private void btnGetFreRange_Click(object sender, EventArgs e)
        {
            Device.GetFreqRange();
        }
        private void btnSetFreRange_Click(object sender, EventArgs e)
        {
            Device.SetFreqRange(Convert.ToInt32(cmbFreqRange.SelectedValue));
        }
        private void btnGetAutoFree_Click(object sender, EventArgs e)
        {
            Device.GetAutoFree();
        }
        private void btnSetAutoFree_Click(object sender, EventArgs e)
        {
            AutoFree autoFree = new AutoFree()
            {
                OpenClose = (byte)cmbAutoFree.SelectedIndex,
                FreeTime = ushort.Parse(txtAutoFreeTime.Text),
            };
            Device.SetAutoFree(autoFree);
        }
        private void btnGetFilter_Click(object sender, EventArgs e)
        {
            Device.GetFilter();
        }
        private void btnSetFilter_Click(object sender, EventArgs e)
        {
            try
            {
                ushort repeatTime = 0;
                int rssiMax = 0;
                if (!ushort.TryParse(txtFilterRepeatTime.Text, out repeatTime))
                {
                    ShowMessage("Repeat Time is invalid. Please try again.");
                    return;
                }
                //if (!int.TryParse(txtRSSIMax.Text, out rssiMax) || rssiMax > 0 || rssiMax < -110)
                if (!int.TryParse(txtRSSIMax.Text, out rssiMax) || rssiMax > 110 || rssiMax < 0)
                    {
                    ShowMessage("RSSI Max is invalid. Please try again.");
                    this.txtRSSIMax.Text = "0";
                    return;
                }
                Device.SetFilter(repeatTime, rssiMax*-1);
            }
            catch (OverflowException ex)
            {
                ShowMessage("The input is invalid. Please try again.");
            }
            catch (Exception ex2)
            {
                ShowMessage($"SetFilter:{ex2.Message}");
            }
        }
        private void btnGetResidenceTime_Click(object sender, EventArgs e)
        {
            Device.GetResidenceTime();
        }
        private void btnSetResidenceTime_Click(object sender, EventArgs e)
        {
            try
            {
                ResidenceTime residenceTime = new ResidenceTime()
                {
                    AntMax = ushort.Parse(txtAntMax.Text),
                    FreqPoint = ushort.Parse(txtFreqPoint.Text),
                };
                Device.SetResidenceTime(residenceTime);
            }
            catch (Exception ex)
            {
                ShowMessage($"SetResidenceTime:{ex.Message}");
            }
        }
        private void tabRFID_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (!isConnected) return;
            if (tabRFID.SelectedIndex == 0)
            {
                isGetAllTabData = true;
                btnGetEPCBaseband_Click(null, null);
            }
        }
        #endregion Base
        #region Base-1
        private void btnGetGBBaseband_Click(object sender, EventArgs e)
        {
            Device.GetGbBaseband();
        }

        private void btnSetGBBaseband_Click(object sender, EventArgs e)
        {

        }
        #endregion Base-1
        #region F-hop
        bool IsSetFreqPoint = false;
        private void btnSetFreqPoint_Click(object sender, EventArgs e)
        {
            IsSetFreqPoint = true;
            Device.SetFreqRange(Convert.ToInt32(cmbFreqPoint.SelectedValue));
        }
        private void btnGetFrequency_Click(object sender, EventArgs e)
        {
            Device.GetFrequency();
        }
        private void btnSetFhop_Click(object sender, EventArgs e)
        {
            try
            {
                byte[] pointIndexList = { };
                if (txtPointList.Text != "")
                {
                    string[] points = txtPointList.Text.Split(',');
                    pointIndexList = new byte[points.Length];
                    for (int i = 0; i < points.Length; i++)
                    {
                        pointIndexList[i] = (byte)lbFrequencies.Items.IndexOf(points[i]);
                    }
                }
                Device.SetFrequency((Types.FrequencyAutoFixed)cmbFreqAutoFixed.SelectedIndex, pointIndexList, cbPowerDownSave.Checked);
            }
            catch (Exception ex)
            {
                ShowMessage($"SetFhop:{ex.Message}");
            }
        }
        private void btnListLeftToRight_Click(object sender, EventArgs e)
        {
            string fres = "";
            for (int i = 0; i < lbFrequencies.SelectedItems.Count; i++)
            {
                if (txtPointList.Text.IndexOf(lbFrequencies.SelectedItems[i].ToString()) >= 0) continue;
                if (fres == "") fres = lbFrequencies.SelectedItems[i].ToString();
                else fres += "," + lbFrequencies.SelectedItems[i].ToString();
                //lbFrequencies.Items.Remove(lbFrequencies.SelectedItems[i]);
            }
            if (fres != "") AppendToPointList(fres);
        }
        private void btnAllToRight_Click(object sender, EventArgs e)
        {
            string fres = "";
            for (int i = 0; i < lbFrequencies.Items.Count; i++)
            {
                if (txtPointList.Text.IndexOf(lbFrequencies.Items[i].ToString()) >= 0) continue;
                if (fres == "") fres = lbFrequencies.Items[i].ToString();
                else fres += "," + lbFrequencies.Items[i].ToString();
            }
            //lbFrequencies.Items.Clear();
            if (fres != "") AppendToPointList(fres);
        }

        private void btnAllToLeft_Click(object sender, EventArgs e)
        {
            //string[] list = txtPointList.Text.Split(new char[] { ',' });
            //foreach (string item in list)
            //{
            //    lbFrequencies.Items.Add(item);
            //}
            txtPointList.Text = "";
        }

        void AppendToPointList(string listText)
        {
            if (txtPointList.Text == "") txtPointList.Text = listText;
            else txtPointList.Text += "," + listText;
        }
        private void cmbFreqPoint_SelectedIndexChanged(object sender, EventArgs e)
        {
            ArrayList arrayList = new ArrayList();
            Device.GetFreqListByFreqPoint(((ComboBox)sender).SelectedValue, ref arrayList);
            lbFrequencies.DataSource = arrayList;
            if (txtPointList.Tag != null) {
                if (cmbFreqPoint.SelectedIndex != currentFrequencyRangeIndex)
                {
                    txtPointList.Text = "";
                }
            }
            //SetPointList(txtPointList.Tag.ToString());
        }
        #endregion F-hop
        #region Read
        private void btnRead_Click(object sender, EventArgs e)
        {
            try
            {
                readType = ReadType.Read;
                txtReadTagData.Text = "";
                ReadParameters readEpc = new ReadParameters()
                {
                    Ant1 = cbIvtAnt1.Checked,
                    Ant2 = cbIvtAnt2.Checked,
                    Ant3 = cbIvtAnt3.Checked,
                    Ant4 = cbIvtAnt4.Checked,
                    Ant5 = cbIvtAnt5.Checked,
                    Ant6 = cbIvtAnt6.Checked,
                    Ant7 = cbIvtAnt7.Checked,
                    Ant8 = cbIvtAnt8.Checked,
                    TIDMode = rbTIDModeA.Checked ? Types.TIDMode.Adaptive : Types.TIDMode.FixedLength,
                    ReadTagArea = rbEPCRead.Checked ? Types.TagArea.EPC : rbTIDRead.Checked ? Types.TagArea.TID : rbUserDataRead.Checked ? Types.TagArea.User : Types.TagArea.Reserved,
                    StartAddress = int.Parse(txtReadStartAddress.Text == "" ? "0" : txtReadStartAddress.Text),
                    ReadDataLength = byte.Parse(txtReadLength.Text == "" ? "0" : txtReadLength.Text),
                    Password = txtReadPwd.Text,
                };
                if (cbReadMatch.Checked)
                {
                    readEpc.MatchArea = rbEPCr.Checked ? Types.MatchArea.EPC : rbTIDr.Checked ? Types.MatchArea.TID : Types.MatchArea.User;
                    readEpc.MatchStartAddress = int.Parse(txtReadMatchStartAddress.Text == "" ? "0" : txtReadMatchStartAddress.Text);
                    readEpc.MatchData = txtReadMatchData.Text;
                }
                else
                {
                    readEpc.MatchArea = Types.MatchArea.None;
                    readEpc.MatchData = "";
                }
                Device.BaseRead(readEpc);
            }
            catch (Exception ex)
            {
                ShowMessage($"Read:{ex.Message}");
            }
        }
        private void cbReadMatch_CheckedChanged(object sender, EventArgs e)
        {
            if (cbReadMatch.Checked && dgvTags.SelectedRows.Count > 0)
            {
                txtReadMatchData.Text = dgvTags.SelectedRows[0].Cells[rbEPCr.Checked ? 4 : rbTIDr.Checked ? 8 : 9].Value.ToString();
                txtReadStartAddress.Text = rbEPCRead.Checked ? "2" : "0";
            }
            txtReadMatchStartAddress.Text = rbEPCr.Checked ? "2" : "0";
        }
        private void rbReadMatchArea_CheckedChanged(object sender, EventArgs e)
        {
            if (cbReadMatch.Checked && dgvTags.SelectedRows.Count > 0)
            {
                RadioButton ck = ((RadioButton)sender);
                if (ck.Checked) txtReadMatchData.Text = dgvTags.SelectedRows[0].Cells[ck.Equals(rbEPCr) ? 4 : ck.Equals(rbTIDr) ? 8 : 9].Value.ToString();
            }
            txtReadMatchStartAddress.Text = rbEPCr.Checked ? "2" : "0";
        }
        private void rbEPCRead_CheckedChanged(object sender, EventArgs e)
        {
            txtReadStartAddress.Text = rbEPCRead.Checked ? "2" : "0";
        }
        #endregion Read
        #region Inventory
        System.Timers.Timer InventoryCountTimer;
        System.Timers.Timer InventoryTimer;
        void CountTag(object sender, ElapsedEventArgs e)
        {
            this.Invoke(
                new Action(delegate
                {
                    Console.WriteLine("S:" + DateTime.Now.ToString("G"));
                    total_time++;
                    lblTotalDuration.Text = total_time.ToString();
                    int cursingluationCount = singluationCount;
                    lblSingulationRate.Text = (singluationCount - currentTagCount).ToString();
                    currentTagCount = cursingluationCount;
                    if (InventoryTimerStopped.HasValue && InventoryTimerStopped.Value == true)
                    {
                        InventoryCountTimer.Stop();
                    }
                })
                );
        }
        bool? InventoryTimerStopped = null;
        void StopInventoryWithTimer(object sender, ElapsedEventArgs e)
        {
            this.Invoke(
                new Action(delegate
                {
                    Console.WriteLine("T:" + DateTime.Now.ToString("G"));
                    stopInventoryEvtSource = StopInventoryEvtSource.StopInventory;
                    Device.BaseStop();
                    InventoryTimer.Stop();
                    InventoryTimerStopped = true;
                })
                );
        }
        void GetTemperature(object sender, ElapsedEventArgs e)
        {
            if (isConnected)
            {
                Device.GetTemperatureControl();
            }
            else {
                GetTemperatureTimer?.Stop();
            }
        }
        void InitTimer()
        {
            if (InventoryCountTimer == null)
            {
                InventoryCountTimer = new System.Timers.Timer();
                InventoryCountTimer.Elapsed += new System.Timers.ElapsedEventHandler(CountTag);
                InventoryCountTimer.AutoReset = true;
            }
            if (InventoryTimer == null)
            {
                InventoryTimer = new System.Timers.Timer();
                InventoryTimer.Elapsed += new System.Timers.ElapsedEventHandler(StopInventoryWithTimer);
                InventoryTimer.AutoReset = true;
            }
            if (GetTemperatureTimer == null)
            {
                GetTemperatureTimer = new System.Timers.Timer();
                GetTemperatureTimer.Interval = 5000;
                GetTemperatureTimer.Elapsed += new System.Timers.ElapsedEventHandler(GetTemperature);
                GetTemperatureTimer.AutoReset = true;
            }
        }
        void StartTimers()
        {
            Console.WriteLine($"Start Timers: {DateTime.Now.ToString("G")}");
            if (InventoryCountTimer != null)
            {
                InventoryCountTimer.Interval = 1000;
                //InventoryCountTimer.Enabled = true;
                InventoryCountTimer.Start();
            }
            if (cbIvtTimer.Checked && InventoryTimer != null)
            {
                InventoryTimer.Interval = int.Parse(txtIvtTimems.Text);
                //InventoryCountTimer.Enabled = true;
                InventoryTimer.Start();
                InventoryTimerStopped = false;
            }
            if(!cbIvtTimer.Checked) InventoryTimerStopped = null;
        }
        void StopTimers()
        {
            Console.WriteLine($"Stop Timers: {DateTime.Now.ToString("G")}");
            if (InventoryCountTimer != null)
            {
                InventoryCountTimer.Stop();
                InventoryCountTimer.Close();
            }
            if (InventoryTimer != null)
            {
                InventoryTimer.Stop();
                InventoryTimer.Close();
            }
        }

        private void startInventory_Click(object sender, EventArgs e)
        {
            if (btnStartInventory.Text == "Stop")
            {
                btnStartInventory.Text = "Start";
                stopInventoryEvtSource = StopInventoryEvtSource.StopInventory;
                StopTimers();
                Device.BaseStop();
                inventoryStatus = InventoryStatus.Stopping;
            }
            else
            {
                lblTemperatureWarning.Visible = false;
                lblWorkTemp.Text = "-℃";
                StopTimers();
                if (cbIvtTimer.Checked)
                {
                    int time = -1;
                    if (txtIvtTimems.Text == "" || !int.TryParse(txtIvtTimems.Text, out time) || time == 0) {
                        MessageBox.Show("Please input inventory timer.", "Warning");
                        return;
                    }
                    btnClear_Click(null, null);
                }
                if (ivtTagType == IvtTagType.EPC && rbIvtGB.Checked)
                {
                    ivtTagType = IvtTagType.GB;
                    btnClear_Click(null, null);
                }
                else if (ivtTagType == IvtTagType.GB && rbIvt6c.Checked)
                {
                    ivtTagType = IvtTagType.EPC;
                    btnClear_Click(null, null);
                }
                ivtTagType = rbIvtGB.Checked ? IvtTagType.GB : IvtTagType.EPC;
                DataGridColumnsDisplay();
                btnStartInventory.Text = "Stop";
                readType = ReadType.Inventory;
                InventoryEPC();
                StartTimers();
                inventoryStatus = InventoryStatus.Starting;
                if (inventoryType != InventoryType.None)
                {
                    if ((inventoryType == InventoryType.EPC && !rbIvtEPC.Checked) ||
                        (inventoryType == InventoryType.MagnusS3 && !rbIvtMagnusS3.Checked) ||
                        (inventoryType == InventoryType.Moisture && !rbIvtMoisture.Checked))
                    {
                        btnClear_Click(null, null);
                    }
                }
                inventoryType = rbIvtEPC.Checked ? InventoryType.EPC : rbIvtMagnusS3.Checked ? InventoryType.MagnusS3 : InventoryType.Moisture;
            }
        }
        void DataGridColumnsDisplay()
        {
            dgvTags.Columns[2].Visible = rbIvtMoisture.Checked || rbIvtMagnusS3.Checked;
            dgvTags.Columns[3].Visible = rbIvtMoisture.Checked || rbIvtMagnusS3.Checked;
            dgvTags.Columns[4].Visible = !rbIvtGB.Checked;
            dgvTags.Columns[5].Visible = !rbIvtGB.Checked;
            dgvTags.Columns[6].Visible = rbIvtGB.Checked;//TagCode
            dgvTags.Columns[7].Visible = rbIvtGB.Checked;//TagLength
            dgvTags.Columns[11].Visible = !rbIvtGB.Checked; //EPCBank
            dgvTags.Columns[13].Visible = !rbIvtGB.Checked;//Phase
            dgvTags.Columns[14].Visible = !rbIvtGB.Checked;//Channel
            if (rbIvtEPC.Checked)
            {
                this.dgvTags.Columns[8].Visible = cbIvtTID.Checked;
                this.dgvTags.Columns[9].Visible = cbIvtUserData.Checked;
                this.dgvTags.Columns[10].Visible = cbIvtReservedData.Checked && !rbIvtGB.Checked;
            }
        }
        private void InventoryEPC()
        {
            stopInventoryEvtSource = StopInventoryEvtSource.StartInventory;
            Device.BaseStop();
            InventoryParameters inventoryParameters = new InventoryParameters()
            {
                Ant1 = cbIvtAnt1.Checked,
                Ant2 = cbIvtAnt2.Checked,
                Ant3 = cbIvtAnt3.Checked,
                Ant4 = cbIvtAnt4.Checked,
                Ant5 = cbIvtAnt5.Checked,
                Ant6 = cbIvtAnt6.Checked,
                Ant7 = cbIvtAnt7.Checked,
                Ant8 = cbIvtAnt8.Checked,
            };
            if (rbIvt6c.Checked)
            {
                inventoryParameters.InventoryType = rbIvtMagnusS3.Checked ? Types.InventoryType.Temperature : rbIvtMoisture.Checked ? Types.InventoryType.Moisture : Types.InventoryType.EPC;
                inventoryParameters.ReadTIDArea = rbIvtEPC.Checked && cbIvtTID.Checked;
                inventoryParameters.ReadUserArea = rbIvtEPC.Checked && cbIvtUserData.Checked;
                inventoryParameters.ReadReservedArea = rbIvtEPC.Checked && cbIvtReservedData.Checked;
                inventoryParameters.ReadEPCBank = rbIvtEPC.Checked && cbIvtEPCBank.Checked;
            }
            if (rbIvtSingle.Checked)
            {
                inventoryParameters.SingleOrRepeat = Types.InventoryMode.Single;
            }
            else
            {
                inventoryParameters.SingleOrRepeat = Types.InventoryMode.Repeat;
            }
            if (cbReadMatch.Checked && txtReadMatchData.Text.Trim() != "" && txtReadMatchStartAddress.Text.Trim() != "")
            {
                inventoryParameters.MatchArea = rbEPCr.Checked ? Types.MatchArea.EPC : rbTIDr.Checked ? Types.MatchArea.TID : Types.MatchArea.User;
                inventoryParameters.MatchData = txtReadMatchData.Text.Trim();
                inventoryParameters.MatchStartAddress = UInt16.Parse(txtReadMatchStartAddress.Text.Trim());
            }
            else
            {
                inventoryParameters.MatchArea = Types.MatchArea.None;
            }
            if (rbIvt6c.Checked) Device.BaseInventory(inventoryParameters);
            else Device.BaseInventoryGB(inventoryParameters);
        }
        private void cbIvtAntAll_CheckedChanged(object sender, EventArgs e)
        {
            cbIvtAnt1.Checked = cbIvtAnt2.Checked = cbIvtAnt3.Checked = cbIvtAnt4.Checked = cbIvtAnt5.Checked = cbIvtAnt6.Checked = cbIvtAnt7.Checked = cbIvtAnt8.Checked = cbIvtAntAll.Checked;
        }
        #endregion Inventory
        #region Write
        private void btnWrite_Click(object sender, EventArgs e)
        {
            try
            {
                if (txtWriteData.Text == "") ShowParamsNullErrorMessage();
                else
                {
                    WriteParameters writeEPC = new WriteParameters()
                    {
                        Ant1 = cbIvtAnt1.Checked,
                        Ant2 = cbIvtAnt2.Checked,
                        Ant3 = cbIvtAnt3.Checked,
                        Ant4 = cbIvtAnt4.Checked,
                        Ant5 = cbIvtAnt5.Checked,
                        Ant6 = cbIvtAnt6.Checked,
                        Ant7 = cbIvtAnt7.Checked,
                        Ant8 = cbIvtAnt8.Checked,
                        DataArea = rbWriteReserved.Checked ? Types.WriteTagArea.Reserved : rbWriteEPC.Checked ? Types.WriteTagArea.EPC : rbWriteTID.Checked ? Types.WriteTagArea.TID : Types.WriteTagArea.User,
                        WordStartAddress = UInt16.Parse(txtWriteStartAddress.Text == "" ? "0" : txtWriteStartAddress.Text),
                        WriteData = txtWriteData.Text.PadRight(4 * Convert.ToInt32(txtWriteLength.Text), '0'),
                        Password = txtWritePwd.Text,
                    };
                    if (cbMatchWrite.Checked)
                    {
                        writeEPC.MatchArea = rbWriteMatchEPC.Checked ? Types.MatchArea.EPC : rbWriteMatchTID.Checked ? Types.MatchArea.TID : Types.MatchArea.User;
                        writeEPC.MatchStartAddress = UInt16.Parse(txtWriteMatchStartAddress.Text == "" ? "0" : txtWriteMatchStartAddress.Text);
                        writeEPC.MatchData = txtWriteMatchData.Text;
                    }
                    else
                    {
                        writeEPC.MatchArea = Types.MatchArea.None;
                    }
                    Device.WriteTag(writeEPC);
                }
            }
            catch (Exception ex)
            {
                ShowMessage($"Write:{ex.Message}");
            }
        }
        private void cbMatchWrite_CheckedChanged(object sender, EventArgs e)
        {
            if (cbMatchWrite.Checked && dgvTags.SelectedRows.Count > 0)
            {
                txtWriteMatchData.Text = dgvTags.SelectedRows[0].Cells[rbWriteMatchEPC.Checked ? 4 : rbWriteMatchTID.Checked ? 8 : 9].Value.ToString();
                txtWriteMatchStartAddress.Text = rbWriteMatchEPC.Checked ? "2" : "0";
                txtWriteStartAddress.Text = rbWriteEPC.Checked ? "2" : "0";
            }
        }
        private void rbWriteMatchArea_CheckedChanged(object sender, EventArgs e)
        {
            if (cbMatchWrite.Checked && dgvTags.SelectedRows.Count > 0)
            {
                RadioButton ck = ((RadioButton)sender);
                if (ck.Checked) txtWriteMatchData.Text = dgvTags.SelectedRows[0].Cells[ck.Equals(rbWriteMatchEPC) ? 4 : ck.Equals(rbWriteMatchTID) ? 8 : 9].Value.ToString();
                txtWriteMatchStartAddress.Text = rbWriteMatchEPC.Checked ? "2" : "0";
            }
        }
        private void rbWriteEPC_CheckedChanged(object sender, EventArgs e)
        {
            txtWriteStartAddress.Text = rbWriteEPC.Checked ? "2" : "0";
        }
        #endregion Write
        #region Lock
        private void btnLock_Click(object sender, EventArgs e)
        {
            try
            {
                LockParameters lockParameters = new LockParameters()
                {
                    Ant1 = cbIvtAnt1.Checked,
                    Ant2 = cbIvtAnt2.Checked,
                    Ant3 = cbIvtAnt3.Checked,
                    Ant4 = cbIvtAnt4.Checked,
                    Ant5 = cbIvtAnt5.Checked,
                    Ant6 = cbIvtAnt6.Checked,
                    Ant7 = cbIvtAnt7.Checked,
                    Ant8 = cbIvtAnt8.Checked,
                    LockArea = (byte)cmbLockArea.SelectedIndex,
                    LockType = (byte)cmbLockTypes.SelectedIndex,
                    Password = txtLockPwd.Text,
                };
                if (cbLockMatch.Checked)
                {
                    lockParameters.MatchArea = rbLockMatchEPC.Checked ? Types.MatchArea.EPC : rbLockMatchTID.Checked ? Types.MatchArea.TID : Types.MatchArea.User;
                    lockParameters.MatchData = txtLockMatchData.Text;
                    lockParameters.MatchStartAddress = UInt16.Parse(txtLockStartAddress.Text);
                }
                else
                {
                    lockParameters.MatchArea = Types.MatchArea.None;
                }
                Device.LockTag(lockParameters);
            }
            catch (Exception ex)
            {
                ShowMessage($"Lock:{ex.Message}");
            }
        }
        private void ckLockMatch_CheckedChanged(object sender, EventArgs e)
        {
            if (cbLockMatch.Checked && dgvTags.SelectedRows.Count > 0)
            {
                txtLockMatchData.Text = dgvTags.SelectedRows[0].Cells[rbLockMatchEPC.Checked ? 4 : rbLockMatchTID.Checked ? 8 : 9].Value.ToString();
            }
        }
        private void rbLockMatchArea_CheckedChanged(object sender, EventArgs e)
        {
            if (cbLockMatch.Checked && dgvTags.SelectedRows.Count > 0)
            {
                RadioButton ck = ((RadioButton)sender);
                if (ck.Checked) txtLockMatchData.Text = dgvTags.SelectedRows[0].Cells[ck.Equals(rbLockMatchEPC) ? 4 : ck.Equals(rbLockMatchTID) ? 8 : 9].Value.ToString();
            }
        }
        private void cmbLockTypes_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (cmbLockTypes.SelectedIndex == 0 || cmbLockTypes.SelectedIndex == 2) btnLock.Text = "UnLock";
            else btnLock.Text = "Lock";
        }
        #endregion Lock
        #region Kill
        private void btnKill_Click_1(object sender, EventArgs e)
        {
            try
            {
                KillParameters killParameters = new KillParameters()
                {
                    Ant1 = cbIvtAnt1.Checked,
                    Ant2 = cbIvtAnt2.Checked,
                    Ant3 = cbIvtAnt3.Checked,
                    Ant4 = cbIvtAnt4.Checked,
                    Ant5 = cbIvtAnt5.Checked,
                    Ant6 = cbIvtAnt6.Checked,
                    Ant7 = cbIvtAnt7.Checked,
                    Ant8 = cbIvtAnt8.Checked,
                    Password = txtKillPwd.Text,
                };
                if (cbKillMatch.Checked)
                {
                    killParameters.MatchArea = rbKillMatchEPC.Checked ? Types.MatchArea.EPC : rbKillMatchTID.Checked ? Types.MatchArea.TID : Types.MatchArea.User;
                    killParameters.MatchData = txtKillMatchData.Text;
                    killParameters.MatchStartAddress = UInt16.Parse(txtKillStartAddress.Text);
                }
                else
                {
                    killParameters.MatchArea = Types.MatchArea.None;
                }
                Device.KillTag(killParameters);
            }
            catch (Exception ex)
            {
                ShowMessage($"Kill:{ex.Message}");
            }
        }
        private void cbKillMatch_CheckedChanged(object sender, EventArgs e)
        {
            if (cbKillMatch.Checked && dgvTags.SelectedRows.Count > 0)
            {
                txtKillMatchData.Text = dgvTags.SelectedRows[0].Cells[rbKillMatchEPC.Checked ? 4 : rbKillMatchTID.Checked ? 8 : 9].Value.ToString();
                txtKillStartAddress.Text = "2";
            }
        }
        private void rbKillMatchArea_CheckedChanged(object sender, EventArgs e)
        {
            if (cbKillMatch.Checked && dgvTags.SelectedRows.Count > 0)
            {
                txtKillStartAddress.Text = rbKillMatchEPC.Checked ? "2" : "0";
                RadioButton ck = ((RadioButton)sender);
                if (ck.Checked) txtKillMatchData.Text = dgvTags.SelectedRows[0].Cells[ck.Equals(rbKillMatchEPC) ? 4 : ck.Equals(rbKillMatchTID) ? 8 : 9].Value.ToString();
            }
        }
        #endregion Kill
        private void dgvTags_CellClick(object sender, DataGridViewCellEventArgs e)
        {
            if (e.RowIndex > -1)
            {
                DataGridViewRow dgvTagSelectedRow = dgvTags.Rows[e.RowIndex];
                if (tabSettings.SelectedIndex == 2 && tabOperate.SelectedIndex == 0)
                {
                    if (cbReadMatch.Checked) txtReadMatchData.Text = dgvTagSelectedRow.Cells[rbEPCr.Checked ? 4 : rbTIDr.Checked ? 8 : 9].Value.ToString();
                }
                if (tabOperate.SelectedIndex == 1)
                {
                    if (cbMatchWrite.Checked) txtWriteMatchData.Text = dgvTagSelectedRow.Cells[rbWriteMatchEPC.Checked ? 4 : rbWriteMatchTID.Checked ? 8 : 9].Value.ToString();
                }
                if (tabOperate.SelectedIndex == 2)
                {
                    if (cbLockMatch.Checked) txtLockMatchData.Text = dgvTagSelectedRow.Cells[rbLockMatchEPC.Checked ? 4 : rbLockMatchTID.Checked ? 8 : 9].Value.ToString();
                }
                if (tabOperate.SelectedIndex == 3)
                {
                    if (cbKillMatch.Checked) txtKillMatchData.Text = dgvTagSelectedRow.Cells[rbKillMatchEPC.Checked ? 4 : rbKillMatchTID.Checked ? 8 : 9].Value.ToString();
                }
            }
        }
        #region self-defined functions
        void ShowMessage(string message)
        {
            this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " " + message + Environment.NewLine);
            Devmes.ScrollToCaret();
        }
        void ShowParamsNullErrorMessage()
        {
            this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Parameters can not be null." + Environment.NewLine);
            Devmes.ScrollToCaret();
        }
        void ShowParamsErrorMessage()
        {
            this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Parameters error." + Environment.NewLine);
            Devmes.ScrollToCaret();
        }
        #endregion self-defined functions
        #region upgrade
        Upgrade frmUpgrade;
        void CloseUpgradeWindow(bool isRestart)
        {
            this.Invoke((Action)(() =>
            {
                if (isRestart)
                {
                    if (connectType == ConnectType.TCP) btnTcpDiscon_Click(null, null);
                    else if (connectType == ConnectType.RS232) btnRS232Disconnect_click(null, null);
                    else if (connectType == ConnectType.RS485) btnRS485Disconnect_Click(null, null);
                    else btnTCPDiscServer_Click(null, null);
                }
                frmUpgrade.Close();
                frmUpgrade = null;
            }));
        }
        void CloseUpdateWindowWithNothing()
        {
            if(isConnected) GetTemperatureTimer?.Start();//更新画面打开无操作就关闭的场合
        }
        private void btnUpgradeApp_Click(object sender, EventArgs e)
        {
            GetTemperatureTimer.Stop();//更新时停止温度timer

            frmUpgrade = new Upgrade(UpgradeType.UpgradeApp);
            frmUpgrade.connectType = this.connectType;
            byte address = 0;
            if (this.connectType == ConnectType.RS485 && byte.TryParse(txtBaudRate485Address.Text, out address)) frmUpgrade.rs485Address = address;
            frmUpgrade.closeUpdateWindow = CloseUpgradeWindow;
            frmUpgrade.closeUpdateWindowWithNothing = CloseUpdateWindowWithNothing;
            frmUpgrade.Location = new Point(this.Location.X + (this.Width - frmUpgrade.Width) / 2, (this.Location.Y + (this.Height - frmUpgrade.Height) / 2));
            frmUpgrade.ShowDialog();
        }
        private void btnUpgradeBaseband_Click(object sender, EventArgs e)
        {
            GetTemperatureTimer.Stop();//更新时停止温度timer

            frmUpgrade = new Upgrade(UpgradeType.UpgradeBaseband);
            frmUpgrade.closeUpdateWindow = CloseUpgradeWindow;
            frmUpgrade.closeUpdateWindowWithNothing = CloseUpdateWindowWithNothing;
            frmUpgrade.connectType = this.connectType;
            byte address = 0;
            if (this.connectType == ConnectType.RS485 && byte.TryParse(txtBaudRate485Address.Text, out address)) frmUpgrade.rs485Address = address;
            frmUpgrade.Location = new Point(this.Location.X + (this.Width - frmUpgrade.Width) / 2, (this.Location.Y + (this.Height - frmUpgrade.Height) / 2));
            frmUpgrade.ShowDialog();
        }
        #endregion upgrade

        private void rbIvtGB_CheckedChanged(object sender, EventArgs e)
        {
            RadioButton cb = (RadioButton)sender;
            if (cb.Checked)
            {
                rbIvtEPC.Checked = true;
                cbIvtReservedData.Checked = false;
                cbIvtEPCBank.Checked = false;
                InventoryCtrlsDisplay(false);
            }
            
        }
        private void rbIvt6c_CheckedChanged(object sender, EventArgs e)
        {
            RadioButton cb = (RadioButton)sender;
            if (cb.Checked)
            {
                InventoryCtrlsDisplay(true);
            }
        }
        void InventoryCtrlsDisplay(bool enabled)
        {
            gbIvtType.Enabled = enabled;
            cbIvtReservedData.Enabled = enabled;
            gbIvtDataArea.Enabled = enabled;
        }

        private void btnTcpServer_Click(object sender, EventArgs e)
        {
           if (TcpServerIP.Text == "")
            {
                ShowMessage("Please input IP address.");
                return;
            }
            if (TcpServerPort.Text == "")
            {
                ShowMessage("Please input port.");
                return;
            }
            int port = 0;
            if (!int.TryParse(TcpServerPort.Text, out port))
            {
                ShowMessage("Please input correct port.");
                return;
            }
            this.btnTcpServer.Enabled = false;
            Cursor.Current = Cursors.WaitCursor;

            UInt32 error = Device.CreatTcpServer(TcpServerIP.Text, port);
            if (error == 0)
            {
                lblWorkTemp.Text = "-℃";
                lblTemperatureWarning.Visible = false;
                GetTemperatureTimer?.Start();
                connectType = ConnectType.TCPS;
                //WhenConnected();
                isRevBaseVersion = false;
                Thread.Sleep(5000);
                GetBaseVersion();
                resetEvent.WaitOne(1000);
                if (isRevBaseVersion ||
                   MessageBox.Show("This is an invalid connection.Do you like to continue?", "Tips", MessageBoxButtons.OKCancel, MessageBoxIcon.Question) == DialogResult.OK)
                {
                    //initConnect = true;
                    isConnected = true;
                    GetReaderInfo();
                }
                else
                {
                    this.btnTcpServer.Enabled = true;
                    btnTCPDiscServer_Click(null, null);
                    return;
                }
                //isConnected = true;
            }
            else
            {
                ShowMessage(" Connect failed.(" + error + ")");
            }

            this.EnableControls();
        }

        private void btnTCPDiscServer_Click(object sender, EventArgs e)
        {
            Disconnect();
        }

        public string GetLoaclIP()
        {
            string rtn = string.Empty;

            if (!System.Net.NetworkInformation.NetworkInterface.GetIsNetworkAvailable())
            {
                rtn = "No Network Available";
            }

            IPHostEntry host = Dns.GetHostEntry(Dns.GetHostName());

            var ippaddress = host
                            .AddressList
                            .FirstOrDefault(ip => ip.AddressFamily == AddressFamily.InterNetwork);

            rtn = ippaddress.ToString();

            return rtn;
        }

        void refreshCmbPorts(ComboBox cmbPort) {
            string[] vcpPort = GetPortList();
            cmbPort.Items.Clear();
            int i = 0;
            //有限判断是否开通端口模式
            if (vcpPort.Length > 0)
            {
                for (i = 0; i < vcpPort.Length; i++)
                {
                    cmbPort.Items.Add(vcpPort[i]);
                }
                cmbPort.SelectedIndex = 0;
            }
        }

        private void lblPortRs232_DoubleClick(object sender, EventArgs e)
        {
            refreshCmbPorts(cmbPortRs232);
        }

        private void lblPortRs485_DoubleClick(object sender, EventArgs e)
        {
            refreshCmbPorts(cmbPortRs485);
        }

        private void cmbPortRs232_Click(object sender, EventArgs e)
        {
            refreshCmbPorts(cmbPortRs232);
        }

        private void cmbPortRs485_DropDown(object sender, EventArgs e)
        {
            refreshCmbPorts(cmbPortRs485);
        }
    }
    public enum InventoryType
    {
        None,
        EPC,
        Moisture,
        MagnusS3
    }
    public enum ReadType
    {
        None,
        Read = 1,
        Inventory = 2,
    }
    public enum StopInventoryEvtSource
    {
        Disconnect,
        StopInventory,
        StartInventory,
    }
    public enum InventoryStatus
    {
        Starting,
        Started,
        Stopping,
        Stopped,
    }
    public enum ConnectType
    {
        None,
        RS232,
        RS485,
        TCP,
        TCPS,
    }
    public enum IvtTagType
    {
        None,
        EPC,
        GB
    }

}
public enum UpgradeType
{
    UpgradeApp,
    UpgradeBaseband,
}


